<?php
/**
 * @file
 * learn_lesson_content.features.node_export_features.inc
 */

/**
 * Implements hook_node_export_features_default().
 */
function learn_lesson_content_node_export_features_default() {
  $node_export = array(
  'code_string' => 'node_export_serialize::a:14:{i:0;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:3:&quot;197&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:11:&quot;Install Git&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;3936b092-f908-c084-edf8-563cca70e1a1&quot;;s:3:&quot;nid&quot;;s:1:&quot;5&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330902206&quot;;s:7:&quot;changed&quot;;s:10:&quot;1351356868&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;027b5839-7a74-af04-6905-fee2d01c7ef4&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1351356868&quot;;s:12:&quot;revision_uid&quot;;s:4:&quot;3628&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:5506:&quot;&lt;emphasis&gt;Note: instructions on command line tools commonly include the prompt, usually a dollar sign ($). Do not type the prompt when you are following the instructions; you only want what follows the prompt.&lt;/emphasis&gt;

&lt;strong&gt;Installing Git on Windows and Mac&lt;/strong&gt;
&lt;ol&gt;
	&lt;li&gt;Download the latest version of Git for your operating system by going to http://git-scm.com/downloads.&lt;/li&gt;
	&lt;li&gt;Run the installer. For Windows, you can accept the defaults as they are all reasonable. On the &quot;Adjusting your PATH environment&quot; screen choose &quot;Run Git from the Windows command prompt.&quot;)&lt;/li&gt;
	&lt;li&gt;To confirm Git has installed correctly, open a terminal window and at the prompt, type \'git\' (without the quotes). A list of the most common Git commands will print to the screen.&lt;/li&gt;
&lt;/ol&gt;

&lt;p&gt;If you use Macports on Mac, you may prefer the following:&lt;/p&gt;
&lt;code&gt; $ sudo port install git-core +bash_completion +doc +gitweb +svn&lt;/code&gt;

&lt;strong&gt; Installing Git on Linux&lt;/strong&gt;
You can find more instructions for your particular distribution at http://git-scm.com/downloads/linux
On RPM-based systems (RHEL, Fedora Core, CentOS, ...), open Terminal and type:
&lt;code&gt;$ sudo yum install git&lt;/code&gt;

On apt-based systems (Debian, Ubuntu, ...), open Terminal and type:
&lt;code&gt;$ sudo apt-get install git-core&lt;/code&gt;

&lt;strong&gt;Moving Around on the command line&lt;/strong&gt;
These are some commonly used commands for moving around from the command line. You should try these out and get familiar with at least these basics so you can use Git effectively from the command line.
&lt;ul&gt;
    &lt;li&gt;pwd (present working directory) &lt;/li&gt;
    &lt;li&gt;ls (list) for information&lt;/li&gt;
    &lt;li&gt;cd (change directory). For example, if you are already in a Drupal root directory, type the following to move to your modules and then themes directories (using .. before a path moves up one directory):
      &lt;code&gt;$ cd modules
      $ cd ../themes&lt;/code&gt;&lt;/li&gt;
    &lt;li&gt;CTRL + C will cancel an action.&lt;/li&gt;
&lt;/ul&gt;

&lt;strong&gt;Basic Configuration&lt;/strong&gt;
These next commands are a simple way to update Git\'s configuration file, .gitconfig. The file is a hidden file that normally lives in your user home directory (e.g. on a Mac, this would be in /Users/myusername/.gitconfig). When you run these commands you won\'t see any response in the terminal, but your .gitconfig file will be updated.

&lt;ol&gt;
  &lt;li&gt;Tell Git who you are. Use whatever name you would like to have publicly associated with your commits. Note that if your name has a space in it, you have to put the quotes around it.
  &lt;code&gt;$ git config --global user.name &quot;Your Name&quot;&lt;/code&gt;&lt;/li&gt;
  &lt;li&gt;Provide your email address where anyone with questions about your commits can contact you.
  &lt;code&gt;$ git config --global user.email yourname@example.com&lt;/code&gt;&lt;/li&gt;
  &lt;li&gt;Set Git to use safe line endings.
  &lt;code&gt;$ git config --global core.safecrlf true&lt;/code&gt;&lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Download a Project Using Git&lt;/strong&gt;
Now you can start to use Git to download, or clone, code from Drupal.org. First we\'ll download a module. You will download the code directly to where you run the command from. For a module, you would typically download it into the proper place within a Drupal site, e.g. drupalroot/modules, so you would want to first cd to that directory and then proceed with a git clone command.
&lt;ol&gt;
  &lt;li&gt;Move into the correct directory for your project, e.g. &lt;code&gt;cd modules&lt;/code&gt; from your Drupal root.
  &lt;li&gt;Find a project on Drupal.org (for example, &lt;a href=&quot;http://drupal.org/project/admin_menu&quot;&gt;Admin Menu&lt;/a&gt;). On the project page, click the &quot;Version control&quot; tab (near the top of the page).&lt;/li&gt;
  &lt;li&gt;Select a version of Drupal from the drop-down list that matches your Drupal site version.&lt;/li&gt;
  &lt;li&gt;Copy the git clone and cd commands listed there. Paste them into your terminal window. (If you are using Git Bash on Windows, you can click the icon on the upper left corner of the application window to get a menu, where you can select Paste, or you can use the shift+insert keyboard shortcut.)&lt;/li&gt;
  &lt;li&gt;Once the clone is complete, try these informational commands:
    &lt;code&gt;$ ls -a&lt;/code&gt;
    &lt;code&gt;$ git status&lt;/code&gt;
     (view the status of your files in the working directory and staging area)
    &lt;code&gt;$ git branch -a&lt;/code&gt;
    (list, create and manage working contexts. The option -a shows both existing and remote tracking branches)
    &lt;code&gt;$ git log -3&lt;/code&gt;
    (shows commit logs. The -3 option limits to the latest 3 commits.)
  &lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Download Drupal Using Git&lt;/strong&gt;
For higher rungs on the Drupal Ladder, you will want to have a Git repository for Drupal core. You can find the correct Git information for Drupal core in the same way as for projects (http://drupal.org/project/drupal/git-instructions). Doing the simple clone command below will download the cutting edge version of Drupal, sometimes referred to as HEAD, which is currently the Drupal 8 development version. Again, this code will be downloaded to the location you are in on the command line, so typically you will download this in the web root folder of your local web server.

&lt;code&gt;git clone http://git.drupal.org/project/drupal.git&lt;/code&gt;

Once you have a Drupal 8 clone, you should always update it to the lastest code before you start new work. You can pull down all of the latest changes from Drupal.org, by moving into your Drupal 8 directory, and then doing a git pull command:

&lt;code&gt;git pull&lt;/code&gt;&quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:5711:&quot;&lt;p&gt;&lt;emphasis&gt;Note: instructions on command line tools commonly include the prompt, usually a dollar sign ($). Do not type the prompt when you are following the instructions; you only want what follows the prompt.&lt;/emphasis&gt;&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Installing Git on Windows and Mac&lt;/strong&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Download the latest version of Git for your operating system by going to &lt;a href=&quot;http://git-scm.com/downloads&quot;&gt;http://git-scm.com/downloads&lt;/a&gt;.&lt;/li&gt;
&lt;li&gt;Run the installer. For Windows, you can accept the defaults as they are all reasonable. On the &quot;Adjusting your PATH environment&quot; screen choose &quot;Run Git from the Windows command prompt.&quot;)&lt;/li&gt;
&lt;li&gt;To confirm Git has installed correctly, open a terminal window and at the prompt, type \'git\' (without the quotes). A list of the most common Git commands will print to the screen.&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;If you use Macports on Mac, you may prefer the following:&lt;/p&gt;
&lt;p&gt;&lt;code&gt; $ sudo port install git-core +bash_completion +doc +gitweb +svn&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;&lt;strong&gt; Installing Git on Linux&lt;/strong&gt;&lt;br /&gt;
You can find more instructions for your particular distribution at &lt;a href=&quot;http://git-scm.com/downloads/linux&quot;&gt;http://git-scm.com/downloads/linux&lt;/a&gt;&lt;br /&gt;
On RPM-based systems (RHEL, Fedora Core, CentOS, ...), open Terminal and type:&lt;br /&gt;&lt;code&gt;$ sudo yum install git&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;On apt-based systems (Debian, Ubuntu, ...), open Terminal and type:&lt;br /&gt;&lt;code&gt;$ sudo apt-get install git-core&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Moving Around on the command line&lt;/strong&gt;&lt;br /&gt;
These are some commonly used commands for moving around from the command line. You should try these out and get familiar with at least these basics so you can use Git effectively from the command line.&lt;/p&gt;
&lt;ul&gt;&lt;li&gt;pwd (present working directory) &lt;/li&gt;
&lt;li&gt;ls (list) for information&lt;/li&gt;
&lt;li&gt;cd (change directory). For example, if you are already in a Drupal root directory, type the following to move to your modules and then themes directories (using .. before a path moves up one directory):&lt;br /&gt;&lt;code&gt;$ cd modules&lt;br /&gt;
      $ cd ../themes&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;CTRL + C will cancel an action.&lt;/li&gt;
&lt;/ul&gt;&lt;p&gt;&lt;strong&gt;Basic Configuration&lt;/strong&gt;&lt;br /&gt;
These next commands are a simple way to update Git\'s configuration file, .gitconfig. The file is a hidden file that normally lives in your user home directory (e.g. on a Mac, this would be in /Users/myusername/.gitconfig). When you run these commands you won\'t see any response in the terminal, but your .gitconfig file will be updated.&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Tell Git who you are. Use whatever name you would like to have publicly associated with your commits. Note that if your name has a space in it, you have to put the quotes around it.&lt;br /&gt;&lt;code&gt;$ git config --global user.name &quot;Your Name&quot;&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;Provide your email address where anyone with questions about your commits can contact you.&lt;br /&gt;&lt;code&gt;$ git config --global user.email yourname@example.com&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;Set Git to use safe line endings.&lt;br /&gt;&lt;code&gt;$ git config --global core.safecrlf true&lt;/code&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Download a Project Using Git&lt;/strong&gt;&lt;br /&gt;
Now you can start to use Git to download, or clone, code from Drupal.org. First we\'ll download a module. You will download the code directly to where you run the command from. For a module, you would typically download it into the proper place within a Drupal site, e.g. drupalroot/modules, so you would want to first cd to that directory and then proceed with a git clone command.&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Move into the correct directory for your project, e.g. &lt;code&gt;cd modules&lt;/code&gt; from your Drupal root.
&lt;/li&gt;&lt;li&gt;Find a project on Drupal.org (for example, &lt;a href=&quot;http://drupal.org/project/admin_menu&quot;&gt;Admin Menu&lt;/a&gt;). On the project page, click the &quot;Version control&quot; tab (near the top of the page).&lt;/li&gt;
&lt;li&gt;Select a version of Drupal from the drop-down list that matches your Drupal site version.&lt;/li&gt;
&lt;li&gt;Copy the git clone and cd commands listed there. Paste them into your terminal window. (If you are using Git Bash on Windows, you can click the icon on the upper left corner of the application window to get a menu, where you can select Paste, or you can use the shift+insert keyboard shortcut.)&lt;/li&gt;
&lt;li&gt;Once the clone is complete, try these informational commands:&lt;br /&gt;&lt;code&gt;$ ls -a&lt;/code&gt;&lt;br /&gt;&lt;code&gt;$ git status&lt;/code&gt;&lt;br /&gt;
     (view the status of your files in the working directory and staging area)&lt;br /&gt;&lt;code&gt;$ git branch -a&lt;/code&gt;&lt;br /&gt;
    (list, create and manage working contexts. The option -a shows both existing and remote tracking branches)&lt;br /&gt;&lt;code&gt;$ git log -3&lt;/code&gt;&lt;br /&gt;
    (shows commit logs. The -3 option limits to the latest 3 commits.)
  &lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Download Drupal Using Git&lt;/strong&gt;&lt;br /&gt;
For higher rungs on the Drupal Ladder, you will want to have a Git repository for Drupal core. You can find the correct Git information for Drupal core in the same way as for projects (&lt;a href=&quot;http://drupal.org/project/drupal/git-instructions&quot;&gt;http://drupal.org/project/drupal/git-instructions&lt;/a&gt;). Doing the simple clone command below will download the cutting edge version of Drupal, sometimes referred to as HEAD, which is currently the Drupal 8 development version. Again, this code will be downloaded to the location you are in on the command line, so typically you will download this in the web root folder of your local web server.&lt;/p&gt;
&lt;p&gt;&lt;code&gt;git clone http://git.drupal.org/project/drupal.git&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;Once you have a Drupal 8 clone, you should always update it to the lastest code before you start new work. You can pull down all of the latest changes from Drupal.org, by moving into your Drupal 8 directory, and then doing a git pull command:&lt;/p&gt;
&lt;p&gt;&lt;code&gt;git pull&lt;/code&gt;&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:1:{s:3:&quot;und&quot;;a:3:{i:0;a:1:{s:5:&quot;value&quot;;s:1:&quot;6&quot;;}i:1;a:1:{s:5:&quot;value&quot;;s:1:&quot;7&quot;;}i:2;a:1:{s:5:&quot;value&quot;;s:1:&quot;8&quot;;}}}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;other&quot;;}}}s:17:&quot;field_lesson_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;other&quot;;}}}s:26:&quot;field_lesson_prerequisites&quot;;a:0:{}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:1174:&quot;While climbing the Drupal Ladder, Git gives you easy ways to manage changes to the code:  you can apply a patch for testing, tweak the patch, experiment, re-roll it, and get back safely to where you started.

This lesson will help you install Git so that you can use it from the command line. GUI versions also exist, but for basic operations it is generally held that the command line is simpler. When you get instructions on drupal.org, while climbing the Drupal Ladder, or when asking for advice on how to use Git, the instructions will assume a command line.
Some steps are specific to your platform. The following platforms are covered in this lesson:
&lt;ul&gt;&lt;li&gt;Mac OS X&lt;/li&gt;
&lt;li&gt;Windows&lt;/li&gt;
&lt;li&gt;Linux&lt;/li&gt;
&lt;/ul&gt;
&lt;div class=&quot;resources&quot;&gt;
&lt;strong&gt;Resources:&lt;/strong&gt;
&lt;ul&gt;
&lt;li&gt;Read more Git documentation on &lt;a href=&quot;http://drupal.org/documentation/git&quot;&gt;Drupal.org\'s Git page&lt;/a&gt;.&lt;/li&gt;
&lt;li&gt;Take a great Git tutorial at &lt;a href=&quot;http://gitimmersion.com/&quot;&gt;Git Immersion - commonly used commands as a long series of short tutorials.&lt;/li&gt;
&lt;li&gt;There is a &lt;a href=&quot;http://drupalize.me/videos/install-git&quot;&gt;short video&lt;/a&gt; that walks through this lesson.&lt;/li&gt;
&lt;/div&gt; &quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:1186:&quot;&lt;p&gt;While climbing the Drupal Ladder, Git gives you easy ways to manage changes to the code:  you can apply a patch for testing, tweak the patch, experiment, re-roll it, and get back safely to where you started.&lt;/p&gt;
&lt;p&gt;This lesson will help you install Git so that you can use it from the command line. GUI versions also exist, but for basic operations it is generally held that the command line is simpler. When you get instructions on drupal.org, while climbing the Drupal Ladder, or when asking for advice on how to use Git, the instructions will assume a command line.&lt;br /&gt;
Some steps are specific to your platform. The following platforms are covered in this lesson:&lt;/p&gt;
&lt;ul&gt;&lt;li&gt;Mac OS X&lt;/li&gt;
&lt;li&gt;Windows&lt;/li&gt;
&lt;li&gt;Linux&lt;/li&gt;
&lt;/ul&gt;&lt;div class=&quot;resources&quot;&gt;
&lt;strong&gt;Resources:&lt;/strong&gt;
&lt;ul&gt;&lt;li&gt;Read more Git documentation on &lt;a href=&quot;http://drupal.org/documentation/git&quot;&gt;Drupal.org\'s Git page&lt;/a&gt;.&lt;/li&gt;
&lt;li&gt;Take a great Git tutorial at &lt;a href=&quot;http://gitimmersion.com/&quot;&gt;Git Immersion - commonly used commands as a long series of short tutorials.&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;There is a &lt;a href=&quot;http://drupalize.me/videos/install-git&quot;&gt;short video&lt;/a&gt; that walks through this lesson.&lt;/li&gt;
&lt;/ul&gt;&lt;/div&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:37:&quot;Install Git on your personal computer&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:37:&quot;Install Git on your personal computer&quot;;}}}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;up-to-date&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1351356868&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;178&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1353219766&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:4:&quot;5599&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;1&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:1:&quot;8&quot;;s:6:&quot;source&quot;;s:6:&quot;node/5&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:1;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:4:&quot;1049&quot;;s:3:&quot;uid&quot;;s:1:&quot;3&quot;;s:5:&quot;title&quot;;s:34:&quot;Getting started in the issue queue&quot;;s:3:&quot;log&quot;;s:76:&quot;Changed mention of boston init sandbox to Drupal 8 Sandbox for Drupal Ladder&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;ef943e0d-ef72-a344-99fb-7c9463ee2bfb&quot;;s:3:&quot;nid&quot;;s:1:&quot;4&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330901861&quot;;s:7:&quot;changed&quot;;s:10:&quot;1352755858&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;1d498fa2-d3e4-5754-9160-757d219e8032&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1352755858&quot;;s:12:&quot;revision_uid&quot;;s:2:&quot;68&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:3789:&quot;&lt;strong&gt;Post a sample issue&lt;/strong&gt;
&lt;ol&gt;
    &lt;li&gt;Go to the  &lt;a href=&quot;http://drupal.org/project/issues/1388780?categories=All&quot;&gt;Drupal 8 Sandbox issue queue&lt;/a&gt; and click the option to Create a new issue.&lt;/li&gt;
&lt;li&gt;Under &lt;strong&gt;Component: &lt;/strong&gt; select &lt;strong&gt;Miscellaneous&lt;/strong&gt;&lt;/li&gt;
&lt;li&gt;Under &lt;strong&gt;Category:&lt;/strong&gt; select &lt;strong&gt;Bug Report&lt;/strong&gt;&lt;/li&gt;
  &lt;li&gt; Copy the following and paste into the &lt;strong&gt;Title&lt;/strong&gt; box:
&lt;code&gt; Rewrite description for URL alias on node/add/*&lt;/code&gt;
   &lt;li&gt; Copy the following and paste into the  &lt;strong&gt;Description&lt;/strong&gt; box:
&lt;code&gt;Note: This issue is being posted here as an exercise by a participant in the learndrupal.org ladder for contributing to core. Please don\'t do anything with this post. The &lt;a href=&quot;http://drupal.org/node/1326088&quot;&gt;real issue&lt;/a&gt; has already been resolved in Drupal 8. If you would like to try this exercise yourself, visit learndrupal.org and click on Drupal Ladder&lt;/code&gt;


&lt;code&gt;Current:&lt;/code&gt;
&lt;code&gt;&amp;lt;code&amp;gt;Optionally specify an alternative URL by which this content can be accessed. For example, type &quot;about&quot; when writing an about page. Use a relative path and don\'t add a trailing slash or the URL alias won\'t work.&amp;lt;/code&amp;gt;&lt;/code&gt;

&lt;code&gt;Proposed:&lt;/code&gt;
&lt;code&gt;&amp;lt;code&amp;gt;The alternative URL for this content. For example, type &quot;about&quot; when creating an about page. Use a relative path without a trailing slash.&amp;lt;/code&amp;gt;&lt;/code&gt;

 &lt;li&gt;Click Save. You now know how to post an issue to a drupal.org issue queue.&lt;/li&gt;&lt;/ol&gt;

&lt;strong&gt;Confirm a reported bug and improve the issue&lt;/strong&gt;
&lt;ol&gt;
   &lt;li&gt;Browse to your Drupal Ladder sandbox on your computer, which you set up as a prerequisite to this lesson, and find the bug you\'ve posted in the issue queue in your site.&lt;/li&gt;
   &lt;li&gt; Post a comment to your issue indicating whether you were able or unable to reproduce the bug (in this case, whether you found the confusing text and agree that the proposed alternative is better). Include documentation about how to reproduce the bug (e.g. &quot;create a new piece of content, scroll down and click the URL settings tab to locate the help text&quot;). Finally, upload a screen shot with an arrow, circle, or some sort of highlighting that shows other readers what needs to be fixed.&lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Update the issue summary&lt;/strong&gt;
Contributors are strongly encouraged to use the &lt;a href=&quot;http://drupal.org/node/1155816&quot;&gt;drupal.org issue summary template&lt;/a&gt;, especially for posts with lots and lots of comments. Take a minute to familiarize yourself with the template and use it to re-write the issue post you just created. Under sections that are not applicable, like API Changes, just say &amp;quot;none.&amp;quot; If you don\'t know, just say &amp;quot;I\'m not sure.&amp;quot; (See an &lt;a href=&quot;http://drupal.org/node/1005570&quot;&gt;exemplary issue post&lt;/a&gt;.)

&lt;strong&gt;Tips&lt;/strong&gt;
&lt;ul&gt;
    &lt;li&gt;There\'s a &lt;a href=&quot;http://drupal.org/project/issues/search/drupal?issue_tags=Novice&quot;&gt;list of Novice bugs&lt;/a&gt; on drupal.org that are supposed to be good for beginners.&lt;/li&gt;
    &lt;li&gt;When working on real, unresolved issues, double check if this bug has been reported or resolved elsewhere. If it has, change the issue\'s to status &amp;quot;closed (duplicate)&amp;quot; and post a link to the duplicated issue.&lt;/li&gt;
   &lt;li&gt;If the software works as it\'s supposed to, the issue you\'re working on is not really a bug. Change the issue\'s category from &amp;quot;bug report&amp;quot; to &amp;quot;support request&amp;quot; (questions about how to use the software) or &amp;quot;feature request&amp;quot; (suggestions for other functionality that might be nice to add to the software) then move onto the next reported bug. (The fourth category, &quot;task&quot; is usually reserved for maintainers to track their to do lists.)&lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:3736:&quot;&lt;p&gt;&lt;strong&gt;Post a sample issue&lt;/strong&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Go to the  &lt;a href=&quot;http://drupal.org/project/issues/1388780?categories=All&quot;&gt;Drupal 8 Sandbox issue queue&lt;/a&gt; and click the option to Create a new issue.&lt;/li&gt;
&lt;li&gt;Under &lt;strong&gt;Component: &lt;/strong&gt; select &lt;strong&gt;Miscellaneous&lt;/strong&gt;&lt;/li&gt;
&lt;li&gt;Under &lt;strong&gt;Category:&lt;/strong&gt; select &lt;strong&gt;Bug Report&lt;/strong&gt;&lt;/li&gt;
&lt;li&gt; Copy the following and paste into the &lt;strong&gt;Title&lt;/strong&gt; box:&lt;br /&gt;&lt;code&gt; Rewrite description for URL alias on node/add/*&lt;/code&gt;
&lt;/li&gt;&lt;li&gt; Copy the following and paste into the  &lt;strong&gt;Description&lt;/strong&gt; box:&lt;br /&gt;&lt;code&gt;Note: This issue is being posted here as an exercise by a participant in the learndrupal.org ladder for contributing to core. Please don\'t do anything with this post. The &lt;a href=&quot;http://drupal.org/node/1326088&quot;&gt;real issue&lt;/a&gt; has already been resolved in Drupal 8. If you would like to try this exercise yourself, visit learndrupal.org and click on Drupal Ladder&lt;/code&gt;
&lt;p&gt;&lt;code&gt;Current:&lt;/code&gt;&lt;br /&gt;&lt;code&gt;&amp;lt;code&amp;gt;Optionally specify an alternative URL by which this content can be accessed. For example, type &quot;about&quot; when writing an about page. Use a relative path and don\'t add a trailing slash or the URL alias won\'t work.&amp;lt;/code&amp;gt;&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;&lt;code&gt;Proposed:&lt;/code&gt;&lt;br /&gt;&lt;code&gt;&amp;lt;code&amp;gt;The alternative URL for this content. For example, type &quot;about&quot; when creating an about page. Use a relative path without a trailing slash.&amp;lt;/code&amp;gt;&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;&lt;li&gt;Click Save. You now know how to post an issue to a drupal.org issue queue.&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Confirm a reported bug and improve the issue&lt;/strong&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Browse to your Drupal Ladder sandbox on your computer, which you set up as a prerequisite to this lesson, and find the bug you\'ve posted in the issue queue in your site.&lt;/li&gt;
&lt;li&gt; Post a comment to your issue indicating whether you were able or unable to reproduce the bug (in this case, whether you found the confusing text and agree that the proposed alternative is better). Include documentation about how to reproduce the bug (e.g. &quot;create a new piece of content, scroll down and click the URL settings tab to locate the help text&quot;). Finally, upload a screen shot with an arrow, circle, or some sort of highlighting that shows other readers what needs to be fixed.&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Update the issue summary&lt;/strong&gt;&lt;br /&gt;
Contributors are strongly encouraged to use the &lt;a href=&quot;http://drupal.org/node/1155816&quot;&gt;drupal.org issue summary template&lt;/a&gt;, especially for posts with lots and lots of comments. Take a minute to familiarize yourself with the template and use it to re-write the issue post you just created. Under sections that are not applicable, like API Changes, just say &quot;none.&quot; If you don\'t know, just say &quot;I\'m not sure.&quot; (See an &lt;a href=&quot;http://drupal.org/node/1005570&quot;&gt;exemplary issue post&lt;/a&gt;.)&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Tips&lt;/strong&gt;&lt;/p&gt;
&lt;ul&gt;&lt;li&gt;There\'s a &lt;a href=&quot;http://drupal.org/project/issues/search/drupal?issue_tags=Novice&quot;&gt;list of Novice bugs&lt;/a&gt; on drupal.org that are supposed to be good for beginners.&lt;/li&gt;
&lt;li&gt;When working on real, unresolved issues, double check if this bug has been reported or resolved elsewhere. If it has, change the issue\'s to status &quot;closed (duplicate)&quot; and post a link to the duplicated issue.&lt;/li&gt;
&lt;li&gt;If the software works as it\'s supposed to, the issue you\'re working on is not really a bug. Change the issue\'s category from &quot;bug report&quot; to &quot;support request&quot; (questions about how to use the software) or &quot;feature request&quot; (suggestions for other functionality that might be nice to add to the software) then move onto the next reported bug. (The fourth category, &quot;task&quot; is usually reserved for maintainers to track their to do lists.)&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:1:{s:3:&quot;und&quot;;a:3:{i:0;a:1:{s:5:&quot;value&quot;;s:1:&quot;6&quot;;}i:1;a:1:{s:5:&quot;value&quot;;s:1:&quot;7&quot;;}i:2;a:1:{s:5:&quot;value&quot;;s:1:&quot;8&quot;;}}}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:4:&quot;core&quot;;}}}s:17:&quot;field_lesson_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;other&quot;;}}}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:914:&quot;&lt;ul&gt;
&lt;li&gt;You\'ll be working with a sandbox version of Drupal in this exercise. It has been built with a known issue for you to observe. For this lesson, download and install Drupal 8 from the &lt;a href=&quot;http://drupal.org/project/1388780/git-instructions&quot;&gt;Drupal 8 Sandbox for Drupal Ladder&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;http://drupalladder.org/lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;&gt;Install Git&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;Basic Git knowledge is helpful but not required (&lt;a href=&quot;http://learn.github.com/p/intro.html&quot;&gt;Intro to Git&lt;/a&gt;, &lt;a href=&quot;http://gitref.org/&quot;&gt;Git Reference&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;To provide a screenshot of the bug, you should have a way to capture screen shots. Popular options include: &lt;a href=&quot;http://skitch.com/&quot; title=&quot;Skitch&quot;&gt;Skitch&lt;/a&gt;, &lt;a href=&quot;http://www.techsmith.com/jing.html&quot; title=&quot;Jing&quot;&gt;Jing&lt;/a&gt;, or &lt;a href=&quot;http://awesomescreenshot.com/&quot; title=&quot;Awesome Screenshot&quot;&gt;Awesome Screenshot&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:908:&quot;&lt;ul&gt;&lt;li&gt;You\'ll be working with a sandbox version of Drupal in this exercise. It has been built with a known issue for you to observe. For this lesson, download and install Drupal 8 from the &lt;a href=&quot;http://drupal.org/project/1388780/git-instructions&quot;&gt;Drupal 8 Sandbox for Drupal Ladder&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;http://drupalladder.org/lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;&gt;Install Git&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;Basic Git knowledge is helpful but not required (&lt;a href=&quot;http://learn.github.com/p/intro.html&quot;&gt;Intro to Git&lt;/a&gt;, &lt;a href=&quot;http://gitref.org/&quot;&gt;Git Reference&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;To provide a screenshot of the bug, you should have a way to capture screen shots. Popular options include: &lt;a href=&quot;http://skitch.com/&quot; title=&quot;Skitch&quot;&gt;Skitch&lt;/a&gt;, &lt;a href=&quot;http://www.techsmith.com/jing.html&quot; title=&quot;Jing&quot;&gt;Jing&lt;/a&gt;, or &lt;a href=&quot;http://awesomescreenshot.com/&quot; title=&quot;Awesome Screenshot&quot;&gt;Awesome Screenshot&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:1375:&quot;&lt;p&gt;Project maintainers can spend a lot of time understanding the details of an issue and reproducing reported bugs. By confirming that a bug can be reproduced and improving/writing issue summaries, you help maintainers more efficiently diagnose and respond to bug reports.&lt;/p&gt;

This exercise provides practice with 
&lt;ul&gt;
&lt;li&gt;creating a basic issue post&lt;/li&gt;
&lt;li&gt;confirming a reported bug&lt;/li&gt;
&lt;li&gt;updating the issue to improve it&lt;/li&gt;
&lt;/ul&gt;
&lt;p&gt;This exercise will help you gain Drupal sitebuilding/coding experience. Working on core issues introduces you to things such as the user interface, file structure, feature sets, etc. It offers a great learning experience while providing a significant service to the community. In this exercise we will start by creating a very basic issue, which is sufficient, but not ideal. Then we will test the issue, and follow up and improve the issue to make it more complete.&lt;/p&gt;

&lt;strong&gt;Resources&lt;/strong&gt;
For more background on the issue queue, and how to correctly fill out an issue form, please read the Drupal.org documentation, &lt;a href=&quot;http://drupal.org/node/73179&quot;&gt;Making an issue report&lt;/a&gt;.
There is also a short video, &lt;a href=&quot;http://drupalize.me/videos/getting-started-issue-queue&quot;&gt;Getting started in the issue queue&lt;/a&gt;, which walks through this lesson and includes some background information on the issue queue.&quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:1386:&quot;&lt;p&gt;Project maintainers can spend a lot of time understanding the details of an issue and reproducing reported bugs. By confirming that a bug can be reproduced and improving/writing issue summaries, you help maintainers more efficiently diagnose and respond to bug reports.&lt;/p&gt;
&lt;p&gt;This exercise provides practice with &lt;/p&gt;
&lt;ul&gt;&lt;li&gt;creating a basic issue post&lt;/li&gt;
&lt;li&gt;confirming a reported bug&lt;/li&gt;
&lt;li&gt;updating the issue to improve it&lt;/li&gt;
&lt;/ul&gt;&lt;p&gt;This exercise will help you gain Drupal sitebuilding/coding experience. Working on core issues introduces you to things such as the user interface, file structure, feature sets, etc. It offers a great learning experience while providing a significant service to the community. In this exercise we will start by creating a very basic issue, which is sufficient, but not ideal. Then we will test the issue, and follow up and improve the issue to make it more complete.&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Resources&lt;/strong&gt;&lt;br /&gt;
For more background on the issue queue, and how to correctly fill out an issue form, please read the Drupal.org documentation, &lt;a href=&quot;http://drupal.org/node/73179&quot;&gt;Making an issue report&lt;/a&gt;.&lt;br /&gt;
There is also a short video, &lt;a href=&quot;http://drupalize.me/videos/getting-started-issue-queue&quot;&gt;Getting started in the issue queue&lt;/a&gt;, which walks through this lesson and includes some background information on the issue queue.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:105:&quot;By the end of this exercise you will know how to post and contribute to issues in the Drupal issue queue.&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:105:&quot;By the end of this exercise you will know how to post and contribute to issues in the Drupal issue queue.&quot;;}}}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;up-to-date&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1347417206&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;167&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1351039402&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:2:&quot;42&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;1&quot;;s:4:&quot;name&quot;;s:11:&quot;bryanhirsch&quot;;s:7:&quot;picture&quot;;s:1:&quot;1&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:1:&quot;7&quot;;s:6:&quot;source&quot;;s:6:&quot;node/4&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/1d498fa2-d3e4-5754-9160-757d219e8032&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:2;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:2:&quot;85&quot;;s:3:&quot;uid&quot;;s:2:&quot;11&quot;;s:5:&quot;title&quot;;s:25:&quot;Review and revise patches&quot;;s:3:&quot;log&quot;;s:22:&quot;Changed authoring info&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;0&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;a44dd30d-4417-61d4-39e1-0454d875cb04&quot;;s:3:&quot;nid&quot;;s:2:&quot;13&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903312&quot;;s:7:&quot;changed&quot;;s:10:&quot;1344807453&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;32c03c97-5fd5-c5d4-497c-9c54a309d557&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1344807453&quot;;s:12:&quot;revision_uid&quot;;s:1:&quot;0&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:12312:&quot;&lt;p&gt;
	&lt;strong&gt;Quick Outline&lt;/strong&gt;:&lt;/p&gt;
&lt;ol&gt;
	&lt;li&gt;Search for a patch to review&lt;/li&gt;
	&lt;li&gt;Review the patch&amp;#39;s coding-standards&lt;/li&gt;
	&lt;li&gt;Review the issue&lt;/li&gt;
	&lt;li&gt;Review the patch&lt;/li&gt;
	&lt;li&gt;Write your review&lt;/li&gt;
	&lt;li&gt;Review your review&lt;/li&gt;
	&lt;li&gt;Post your review&lt;/li&gt;
&lt;/ol&gt;
&lt;p&gt;
	&lt;strong&gt;Detailed Steps&lt;/strong&gt;:&lt;/p&gt;
&lt;ol&gt;
	&lt;li&gt;&lt;strong&gt;Search the drupal.org issue queues for a recent, beginner-level (priority=minor) .patch file that &amp;ldquo;needs review&amp;rdquo; or &amp;ldquo;needs work&amp;rdquo;.&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;
				Login to drupal.org&lt;/li&gt;
			&lt;li TYPE=a&gt;
				Click on one of the search links below
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Search &lt;strong&gt;All Projects&lt;/strong&gt; for a recent &lt;strong&gt;Minor&lt;/strong&gt; patch that &lt;strong&gt;Needs Review&lt;/strong&gt;&lt;br /&gt;
						http://drupal.org/project/issues/search?order=last_comment_timestamp&amp;amp;sort=desc&amp;amp;text=.patch&amp;amp;projects=&amp;amp;assigned=&amp;amp;submitted=&amp;amp;participant=&amp;amp;status%5B0%5D=8&amp;amp;priorities%5B0%5D=3&amp;amp;issue_tags_op=or&amp;amp;issue_tags=&lt;/li&gt;
					&lt;li TYPE=i&gt;
						Search &lt;strong&gt;All Projects&lt;/strong&gt; for a recent &lt;strong&gt;Minor&lt;/strong&gt; patch that &lt;strong&gt;Needs Work&lt;/strong&gt;&lt;br /&gt;
						http://drupal.org/project/issues/search?order=last_comment_timestamp&amp;amp;sort=desc&amp;amp;text=.patch&amp;amp;projects=&amp;amp;assigned=&amp;amp;submitted=&amp;amp;participant=&amp;amp;status%5B0%5D=13&amp;amp;priorities%5B0%5D=3&amp;amp;issue_tags_op=or&amp;amp;issue_tags=&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
			&lt;li TYPE=a&gt;
				Scroll the search results table into view.&lt;/li&gt;
			&lt;li TYPE=a&gt;
				Locate the “&lt;strong&gt;Summary&lt;/strong&gt;” column of the search results table.&lt;/li&gt;
			&lt;li TYPE=a&gt;
				Quickly scan patches.
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Click on the first (or next) entry in the “&lt;strong&gt;Summary&lt;/strong&gt;” column to open its issue page.&lt;/li&gt;
					&lt;li TYPE=i&gt;
						For the moment, ignore the issue discussion (yes, that\'s right, ignore it) and simply scroll to the latest .patch file within the issue discussion. &lt;/li&gt;
					&lt;li TYPE=i&gt;
						Click on the .patch file to see if it really is within your patch reviewing ability. You are looking for a patch that does something very basic, like simply removing extra whitespaces, fixing a comment typo, or correcting a very simple snippet of code.&lt;/li&gt;
					&lt;li TYPE=i&gt;
						If the .patch file seems too advanced for you, simply navigate back to the search results table and &lt;strong&gt;repeat the “Quickly scan patches” step&lt;/strong&gt;, using the next entry in the “Summary” column of the search results table. You may have to repeat the “Quickly scan patches” step quite a few times in order to find a patch that suits you. This is expected: methodically scanning through the issue queues for a patch that matches your skill &amp; interest level is a necessary part of the patch review process, regardless of your level of expertise. Take your time.&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
			&lt;li TYPE=a&gt;
				Once you find a .patch file that you can review, make a note of its URL.&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
	&lt;li&gt;&lt;strong&gt;Review the patch\'s coding-standards, making notes as you go.&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;
				The Human Coder Module Pass - Look for any Drupal coding-standards errors in the patch. Don\'t concern yourself with what the patch is supposed to do just yet, or whether the patch\'s approach is even a good idea. Merely examine the structure of the patch to verify that it\'s well-formed according to the coding-standards described at http://drupal.org/coding-standards.
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Manually check the patch for errors in:
						&lt;ul&gt;
							&lt;li&gt;Indenting and Whitespace&lt;/li&gt;
							&lt;li&gt;Operators&lt;/li&gt;
							&lt;li&gt;Casting&lt;/li&gt;
							&lt;li&gt;Control Structures&lt;/li&gt;
							&lt;li&gt;Line length and wrapping&lt;/li&gt;
							&lt;li&gt;Function Calls&lt;/li&gt;
							&lt;li&gt;Function Declarations&lt;/li&gt;
							&lt;li&gt;Class Constructor Calls&lt;/li&gt;
							&lt;li&gt;Arrays&lt;/li&gt;
							&lt;li&gt;Quotes&lt;/li&gt;
							&lt;li&gt;String Concatenations&lt;/li&gt;
							&lt;li&gt;Comments&lt;/li&gt;
							&lt;li&gt;Including Code&lt;/li&gt;
							&lt;li&gt;PHP Code Tags&lt;/li&gt;
							&lt;li&gt;Semicolons&lt;/li&gt;
							&lt;li&gt;Example URLs&lt;/li&gt;
							&lt;li&gt;Naming Conventions&lt;/li&gt;
						&lt;/ul&gt;
					&lt;/li&gt;
					&lt;li TYPE=i&gt;
						If the patch has coding-standards errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any coding standard errors that you find.
					&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
			&lt;li TYPE=a&gt;
				The Bottom Up Pass - If there are any functions in the patch, read the patch in hunks from the bottom up, examining each function\'s readability, without relying on the function\'s comments.
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Look for:
						&lt;ol&gt;
							&lt;li TYPE=A&gt;
								Meaningful Function Names - Determine if each function name is meaningful. A function name should immediately give you a clue about what the function does.&lt;/li&gt;
							&lt;li TYPE=A&gt;
								Small Size - Determine if each function is too large. Would the function be more understandable if it were refactored as several smaller functions?&lt;/li&gt;
							&lt;li TYPE=A&gt;
								Drupal\'s “t() function” - If the function will display any human-readable text on a web page, is the text first run through Drupal\'s t() function? 
								&lt;ul&gt;
									&lt;li&gt;http://api.drupal.org/api/drupal/includes!common.inc/function/t/6&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
						&lt;/ol&gt;
					&lt;/li&gt;
					&lt;li TYPE=i&gt;
						If the patch has any function-readability errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any function-readability errors that you find.
					&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
			&lt;li TYPE=a&gt;
				The Comments Pass - If there are any comments in the patch, examine the comments for readability errors.
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Check the comments for:
						&lt;ol&gt;
							&lt;li TYPE=A&gt;
								Grammar&lt;/li&gt;
							&lt;li TYPE=A&gt;
								Punctuation&lt;/li&gt;
							&lt;li TYPE=A&gt;
								Clarity - Do the comments reflect your understanding of the code and/or maybe clarify parts of the patch you don\'t quite understand?&lt;/li&gt;
						&lt;/ol&gt;
					&lt;/li&gt;
					&lt;li TYPE=i&gt;
						If the patch has any comment-readability errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any comment-readability errors that you find.
					&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
	&lt;li&gt;&lt;strong&gt;Review the issue that the patch attempts to fix, making notes as you go.&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;
				Read the entire Issue Discussion
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Is the Discussion itself understandable?&lt;/li&gt;
					&lt;li TYPE=i&gt;
						Is it an issue at all?&lt;/li&gt;
					&lt;li TYPE=i&gt;
						Is it a duplicate Issue?&lt;/li&gt;
					&lt;li TYPE=i&gt;
						Does the issue summary makes sense?&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
	&lt;li&gt;&lt;strong&gt;Review the patch, making notes as you go.&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;
				Review the patch\'s coding approach
				&lt;ol&gt;
					&lt;li TYPE=i&gt;
						Determine the following:
						&lt;ol&gt;
							&lt;li TYPE=A&gt;
								Is the patch secure?
								&lt;ul&gt;
									&lt;li&gt;http://drupal.org/writing-secure-code&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
							&lt;li TYPE=A&gt;Are the theme functions/files in the proper place?
								&lt;ul&gt;
									&lt;li&gt;http://drupal.org/node/933976&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
							&lt;li TYPE=A&gt;Is it a &quot;stinky?&quot;?
								&lt;ul&gt;
									&lt;li&gt;PDF: http://london2011.drupal.org/sites/default/files/Code%20Smells_0.pdf&lt;/li&gt;
									&lt;li&gt;Video: http://london2011.drupal.org/conference/sessions/code-stinks&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
							&lt;li TYPE=A&gt;
								Does it duplicate code?
								&lt;ul&gt;
									&lt;li&gt;http://drupal.org/node/299202&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
							&lt;li TYPE=A&gt;
								Is the code efficient?
								&lt;ul&gt;
									&lt;li&gt;http://drupal.org/node/328206&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
							&lt;li TYPE=A&gt;Are the patch\'s tests sufficient?
								&lt;ul&gt;
									&lt;li&gt;UI Tests &amp; API Tests: http://groups.drupal.org/node/11020&lt;/li&gt;
									&lt;li&gt;Unit Tests: http://drupal.org/node/811254&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
							&lt;li TYPE=A&gt;Does the patch implements useful tweaks brought up in the discussion?&lt;/li&gt;
						&lt;/ol&gt;
					&lt;/li&gt;
					&lt;li TYPE=i&gt;
						 If the patch has any of the above coding errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any coding errors that you find.&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
			&lt;li TYPE=a&gt;
				Review the patch\'s success at correcting the issue.
				&lt;ol&gt;
					&lt;li TYPE=i&gt;Replicate the issue&lt;/li&gt;
					&lt;li TYPE=i&gt;Apply the patch&lt;/li&gt;
					&lt;li TYPE=i&gt;Determine if the patch corrects the issue.
						&lt;ol&gt;
							&lt;li TYPE=A&gt;
								If it\'s a large patch, confirm that the patch doesn\'t break any of Drupal\'s automated tests
								&lt;ul&gt;
									&lt;li&gt;Simpletest&lt;/li&gt;
									&lt;li&gt;Patch-induced bugs?
										&lt;ul&gt;
											&lt;li&gt;Uninstall the patch&lt;/li&gt;
											&lt;li&gt;Confirm no bugs&lt;/li&gt;
											&lt;li&gt;Re-apply the patch&lt;/li&gt;
											&lt;li&gt;Confirm bugs&lt;/li&gt;
										&lt;/ul&gt;
									&lt;/li&gt;
								&lt;/ul&gt;
							&lt;/li&gt;
						&lt;/ol&gt;
					&lt;/li&gt;
					&lt;li TYPE=i&gt;Make notes about the success of the patch.&lt;/li&gt;
				&lt;/ol&gt;
			&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
	&lt;li&gt;&lt;strong&gt;Write your review.&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;Help the patch proceed.&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
	&lt;li&gt;&lt;strong&gt;Review your review.&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;Are you being constructive, collaborative, and respectful?&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
	&lt;li&gt;&lt;strong&gt;Post your Review&lt;/strong&gt;
		&lt;ol&gt;
			&lt;li TYPE=a&gt;Change the issue\'s status, if applicable. See http://drupal.org/node/156119&lt;/li&gt;
		&lt;/ol&gt;
	&lt;/li&gt;
&lt;/ol&gt;



&lt;strong&gt;.patch Search Tips:&lt;/strong&gt;
Familiarize yourself with drupal.org\'s Advance Search pages, search options, and sort-table-on-heading features. In particular, Drupal Core has its own Advanced Search Page with additional search options (“Version” and “Component”) that are NOT available from the All Projects Advanced Search Pages. The more you can fine-tune your issue queue searches, the easier it will be to find patches in need of review that are both interesting and within your skill level. 

&lt;ul&gt;For example, 
Search Drupal Core for a recent minor Version 7.x patch that Needs Work 
http://drupal.org/project/issues/search/drupal?order=last_comment_timestamp&amp;sort=desc&amp;text=.patch&amp;assigned=&amp;submitted=&amp;participant=&amp;status%5B0%5D=8&amp;priorities%5B0%5D=3&amp;version%5B0%5D=7.x&amp;issue_tags_op=or&amp;issue_tags=
&lt;/ul&gt;
&lt;strong&gt;Patch Reviewing and Revising Tools:&lt;/strong&gt;
&lt;a href=&quot;http://drupal.org/project/dreditor&quot;&gt;Dreditor&lt;/a&gt; (a browser user javascript for reviewing patches and more)
&lt;a href=&quot;http://drupal.org/project/coder&quot;&gt;Coder&lt;/a&gt; module (an automated way of checking for code standards compliance)
&lt;a href=&quot;http://drupal.org/project/drupalcs&quot;&gt;Drupal Code Sniffer&lt;/a&gt; module (runs coding standards validation without loading drupal)
&lt;a href=&quot;http://drupal.org/project/simpletest&quot;&gt;Testing (Simpletest)&lt;/a&gt; module (a D7 core module, known as “Simpletest” in D6; runs .test files for patches &amp; modules that include them)
&lt;a href=&quot;http://drupal.org/project/pareviewsh&quot;&gt;PARevview&lt;/a&gt; (a set of bash scripts for reviewing project applications, which runs some coding tests)

&lt;strong&gt;References:&lt;/strong&gt;
How to Work the Issue Queue - http://drupal.org/node/945492
Diaries of a Core Maintainer #5: The 6-pass patch review - http://webchick.net/6-pass-patch-reviews
Drupal Coding Standards - http://drupal.org/coding-standards
Doxygen and comment formatting conventions - http://drupal.org/node/1354
Code Review of Full Project Applications - http://groups.drupal.org/code-review
Increasing efficiency in manual code reviews - http://groups.drupal.org/node/184389
Writing Secure Code - http://drupal.org/writing-secure-code
Programming Best Practices - http://drupal.org/node/287350
Priority Levels of Drupal - http://drupal.org/node/45111
Clean Code: A Handbook of Agile Software Craftmanship, by Robert C. Martin
This Code Stinks! - PDF: http://london2011.drupal.org/sites/default/files/Code%20Smells_0.pdf
This Code Stinks! - video: http://london2011.drupal.org/conference/sessions/code-stinks
HOWTO: Submit tests with your patch - http://groups.drupal.org/node/11020
Unit Testing with Simpletest - http://drupal.org/node/811254&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:12859:&quot;&lt;p&gt;&lt;strong&gt;Quick Outline&lt;/strong&gt;:&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Search for a patch to review&lt;/li&gt;
&lt;li&gt;Review the patch\'s coding-standards&lt;/li&gt;
&lt;li&gt;Review the issue&lt;/li&gt;
&lt;li&gt;Review the patch&lt;/li&gt;
&lt;li&gt;Write your review&lt;/li&gt;
&lt;li&gt;Review your review&lt;/li&gt;
&lt;li&gt;Post your review&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;	&lt;strong&gt;Detailed Steps&lt;/strong&gt;:&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;&lt;strong&gt;Search the drupal.org issue queues for a recent, beginner-level (priority=minor) .patch file that “needs review” or “needs work”.&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;
				Login to drupal.org&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				Click on one of the search links below
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Search &lt;strong&gt;All Projects&lt;/strong&gt; for a recent &lt;strong&gt;Minor&lt;/strong&gt; patch that &lt;strong&gt;Needs Review&lt;/strong&gt;&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/issues/search?order=last_comment_timestamp&amp;amp;sort=desc&amp;amp;text=.patch&amp;amp;projects=&amp;amp;assigned=&amp;amp;submitted=&amp;amp;participant=&amp;amp;status%5B0%5D=8&amp;amp;priorities%5B0%5D=3&amp;amp;issue_tags_op=or&amp;amp;issue_tags=&quot;&gt;http://drupal.org/project/issues/search?order=last_comment_timestamp&amp;amp;sor...&lt;/a&gt;&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						Search &lt;strong&gt;All Projects&lt;/strong&gt; for a recent &lt;strong&gt;Minor&lt;/strong&gt; patch that &lt;strong&gt;Needs Work&lt;/strong&gt;&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/issues/search?order=last_comment_timestamp&amp;amp;sort=desc&amp;amp;text=.patch&amp;amp;projects=&amp;amp;assigned=&amp;amp;submitted=&amp;amp;participant=&amp;amp;status%5B0%5D=13&amp;amp;priorities%5B0%5D=3&amp;amp;issue_tags_op=or&amp;amp;issue_tags=&quot;&gt;http://drupal.org/project/issues/search?order=last_comment_timestamp&amp;amp;sor...&lt;/a&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				Scroll the search results table into view.&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				Locate the “&lt;strong&gt;Summary&lt;/strong&gt;” column of the search results table.&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				Quickly scan patches.
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Click on the first (or next) entry in the “&lt;strong&gt;Summary&lt;/strong&gt;” column to open its issue page.&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						For the moment, ignore the issue discussion (yes, that\'s right, ignore it) and simply scroll to the latest .patch file within the issue discussion. &lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						Click on the .patch file to see if it really is within your patch reviewing ability. You are looking for a patch that does something very basic, like simply removing extra whitespaces, fixing a comment typo, or correcting a very simple snippet of code.&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						If the .patch file seems too advanced for you, simply navigate back to the search results table and &lt;strong&gt;repeat the “Quickly scan patches” step&lt;/strong&gt;, using the next entry in the “Summary” column of the search results table. You may have to repeat the “Quickly scan patches” step quite a few times in order to find a patch that suits you. This is expected: methodically scanning through the issue queues for a patch that matches your skill &amp;amp; interest level is a necessary part of the patch review process, regardless of your level of expertise. Take your time.&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				Once you find a .patch file that you can review, make a note of its URL.&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;Review the patch\'s coding-standards, making notes as you go.&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;
				The Human Coder Module Pass - Look for any Drupal coding-standards errors in the patch. Don\'t concern yourself with what the patch is supposed to do just yet, or whether the patch\'s approach is even a good idea. Merely examine the structure of the patch to verify that it\'s well-formed according to the coding-standards described at &lt;a href=&quot;http://drupal.org/coding-standards&quot;&gt;http://drupal.org/coding-standards&lt;/a&gt;.
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Manually check the patch for errors in:
&lt;ul&gt;&lt;li&gt;Indenting and Whitespace&lt;/li&gt;
&lt;li&gt;Operators&lt;/li&gt;
&lt;li&gt;Casting&lt;/li&gt;
&lt;li&gt;Control Structures&lt;/li&gt;
&lt;li&gt;Line length and wrapping&lt;/li&gt;
&lt;li&gt;Function Calls&lt;/li&gt;
&lt;li&gt;Function Declarations&lt;/li&gt;
&lt;li&gt;Class Constructor Calls&lt;/li&gt;
&lt;li&gt;Arrays&lt;/li&gt;
&lt;li&gt;Quotes&lt;/li&gt;
&lt;li&gt;String Concatenations&lt;/li&gt;
&lt;li&gt;Comments&lt;/li&gt;
&lt;li&gt;Including Code&lt;/li&gt;
&lt;li&gt;PHP Code Tags&lt;/li&gt;
&lt;li&gt;Semicolons&lt;/li&gt;
&lt;li&gt;Example URLs&lt;/li&gt;
&lt;li&gt;Naming Conventions&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						If the patch has coding-standards errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any coding standard errors that you find.
					&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				The Bottom Up Pass - If there are any functions in the patch, read the patch in hunks from the bottom up, examining each function\'s readability, without relying on the function\'s comments.
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Look for:
&lt;ol&gt;&lt;li type=&quot;A&quot;&gt;
								Meaningful Function Names - Determine if each function name is meaningful. A function name should immediately give you a clue about what the function does.&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;
								Small Size - Determine if each function is too large. Would the function be more understandable if it were refactored as several smaller functions?&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;
								Drupal\'s “t() function” - If the function will display any human-readable text on a web page, is the text first run through Drupal\'s t() function? 
&lt;ul&gt;&lt;li&gt;&lt;a href=&quot;http://api.drupal.org/api/drupal/includes!common.inc/function/t/6&quot;&gt;http://api.drupal.org/api/drupal/includes!common.inc/function/t/6&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						If the patch has any function-readability errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any function-readability errors that you find.
					&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				The Comments Pass - If there are any comments in the patch, examine the comments for readability errors.
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Check the comments for:
&lt;ol&gt;&lt;li type=&quot;A&quot;&gt;
								Grammar&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;
								Punctuation&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;
								Clarity - Do the comments reflect your understanding of the code and/or maybe clarify parts of the patch you don\'t quite understand?&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						If the patch has any comment-readability errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any comment-readability errors that you find.
					&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;Review the issue that the patch attempts to fix, making notes as you go.&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;
				Read the entire Issue Discussion
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Is the Discussion itself understandable?&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						Is it an issue at all?&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						Is it a duplicate Issue?&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						Does the issue summary makes sense?&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;Review the patch, making notes as you go.&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;
				Review the patch\'s coding approach
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;
						Determine the following:
&lt;ol&gt;&lt;li type=&quot;A&quot;&gt;
								Is the patch secure?
&lt;ul&gt;&lt;li&gt;&lt;a href=&quot;http://drupal.org/writing-secure-code&quot;&gt;http://drupal.org/writing-secure-code&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;Are the theme functions/files in the proper place?
&lt;ul&gt;&lt;li&gt;&lt;a href=&quot;http://drupal.org/node/933976&quot;&gt;http://drupal.org/node/933976&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;Is it a &quot;stinky?&quot;?
&lt;ul&gt;&lt;li&gt;PDF: &lt;a href=&quot;http://london2011.drupal.org/sites/default/files/Code%20Smells_0.pdf&quot;&gt;http://london2011.drupal.org/sites/default/files/Code%20Smells_0.pdf&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;Video: &lt;a href=&quot;http://london2011.drupal.org/conference/sessions/code-stinks&quot;&gt;http://london2011.drupal.org/conference/sessions/code-stinks&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;
								Does it duplicate code?
&lt;ul&gt;&lt;li&gt;&lt;a href=&quot;http://drupal.org/node/299202&quot;&gt;http://drupal.org/node/299202&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;
								Is the code efficient?
&lt;ul&gt;&lt;li&gt;&lt;a href=&quot;http://drupal.org/node/328206&quot;&gt;http://drupal.org/node/328206&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;Are the patch\'s tests sufficient?
&lt;ul&gt;&lt;li&gt;UI Tests &amp;amp; API Tests: &lt;a href=&quot;http://groups.drupal.org/node/11020&quot;&gt;http://groups.drupal.org/node/11020&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;Unit Tests: &lt;a href=&quot;http://drupal.org/node/811254&quot;&gt;http://drupal.org/node/811254&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;li type=&quot;A&quot;&gt;Does the patch implements useful tweaks brought up in the discussion?&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;
						 If the patch has any of the above coding errors, fix them (if you can) to help the patch proceed. Otherwise, just make notes about any coding errors that you find.&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;a&quot;&gt;
				Review the patch\'s success at correcting the issue.
&lt;ol&gt;&lt;li type=&quot;i&quot;&gt;Replicate the issue&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;Apply the patch&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;Determine if the patch corrects the issue.
&lt;ol&gt;&lt;li type=&quot;A&quot;&gt;
								If it\'s a large patch, confirm that the patch doesn\'t break any of Drupal\'s automated tests
&lt;ul&gt;&lt;li&gt;Simpletest&lt;/li&gt;
&lt;li&gt;Patch-induced bugs?
&lt;ul&gt;&lt;li&gt;Uninstall the patch&lt;/li&gt;
&lt;li&gt;Confirm no bugs&lt;/li&gt;
&lt;li&gt;Re-apply the patch&lt;/li&gt;
&lt;li&gt;Confirm bugs&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;/ul&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li type=&quot;i&quot;&gt;Make notes about the success of the patch.&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;Write your review.&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;Help the patch proceed.&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;Review your review.&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;Are you being constructive, collaborative, and respectful?&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;Post your Review&lt;/strong&gt;
&lt;ol&gt;&lt;li type=&quot;a&quot;&gt;Change the issue\'s status, if applicable. See &lt;a href=&quot;http://drupal.org/node/156119&quot;&gt;http://drupal.org/node/156119&lt;/a&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;.patch Search Tips:&lt;/strong&gt;&lt;br /&gt;
Familiarize yourself with drupal.org\'s Advance Search pages, search options, and sort-table-on-heading features. In particular, Drupal Core has its own Advanced Search Page with additional search options (“Version” and “Component”) that are NOT available from the All Projects Advanced Search Pages. The more you can fine-tune your issue queue searches, the easier it will be to find patches in need of review that are both interesting and within your skill level. &lt;/p&gt;
&lt;ul&gt;For example,&lt;br /&gt;
Search Drupal Core for a recent minor Version 7.x patch that Needs Work&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/issues/search/drupal?order=last_comment_timestamp&amp;amp;sort=desc&amp;amp;text=.patch&amp;amp;assigned=&amp;amp;submitted=&amp;amp;participant=&amp;amp;status%5B0%5D=8&amp;amp;priorities%5B0%5D=3&amp;amp;version%5B0%5D=7.x&amp;amp;issue_tags_op=or&amp;amp;issue_tags=&quot;&gt;http://drupal.org/project/issues/search/drupal?order=last_comment_timest...&lt;/a&gt;
&lt;/ul&gt;&lt;p&gt;&lt;strong&gt;Patch Reviewing and Revising Tools:&lt;/strong&gt;&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/dreditor&quot;&gt;Dreditor&lt;/a&gt; (a browser user javascript for reviewing patches and more)&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/coder&quot;&gt;Coder&lt;/a&gt; module (an automated way of checking for code standards compliance)&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/drupalcs&quot;&gt;Drupal Code Sniffer&lt;/a&gt; module (runs coding standards validation without loading drupal)&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/simpletest&quot;&gt;Testing (Simpletest)&lt;/a&gt; module (a D7 core module, known as “Simpletest” in D6; runs .test files for patches &amp;amp; modules that include them)&lt;br /&gt;&lt;a href=&quot;http://drupal.org/project/pareviewsh&quot;&gt;PARevview&lt;/a&gt; (a set of bash scripts for reviewing project applications, which runs some coding tests)&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;References:&lt;/strong&gt;&lt;br /&gt;
How to Work the Issue Queue - &lt;a href=&quot;http://drupal.org/node/945492&quot;&gt;http://drupal.org/node/945492&lt;/a&gt;&lt;br /&gt;
Diaries of a Core Maintainer #5: The 6-pass patch review - &lt;a href=&quot;http://webchick.net/6-pass-patch-reviews&quot;&gt;http://webchick.net/6-pass-patch-reviews&lt;/a&gt;&lt;br /&gt;
Drupal Coding Standards - &lt;a href=&quot;http://drupal.org/coding-standards&quot;&gt;http://drupal.org/coding-standards&lt;/a&gt;&lt;br /&gt;
Doxygen and comment formatting conventions - &lt;a href=&quot;http://drupal.org/node/1354&quot;&gt;http://drupal.org/node/1354&lt;/a&gt;&lt;br /&gt;
Code Review of Full Project Applications - &lt;a href=&quot;http://groups.drupal.org/code-review&quot;&gt;http://groups.drupal.org/code-review&lt;/a&gt;&lt;br /&gt;
Increasing efficiency in manual code reviews - &lt;a href=&quot;http://groups.drupal.org/node/184389&quot;&gt;http://groups.drupal.org/node/184389&lt;/a&gt;&lt;br /&gt;
Writing Secure Code - &lt;a href=&quot;http://drupal.org/writing-secure-code&quot;&gt;http://drupal.org/writing-secure-code&lt;/a&gt;&lt;br /&gt;
Programming Best Practices - &lt;a href=&quot;http://drupal.org/node/287350&quot;&gt;http://drupal.org/node/287350&lt;/a&gt;&lt;br /&gt;
Priority Levels of Drupal - &lt;a href=&quot;http://drupal.org/node/45111&quot;&gt;http://drupal.org/node/45111&lt;/a&gt;&lt;br /&gt;
Clean Code: A Handbook of Agile Software Craftmanship, by Robert C. Martin&lt;br /&gt;
This Code Stinks! - PDF: &lt;a href=&quot;http://london2011.drupal.org/sites/default/files/Code%20Smells_0.pdf&quot;&gt;http://london2011.drupal.org/sites/default/files/Code%20Smells_0.pdf&lt;/a&gt;&lt;br /&gt;
This Code Stinks! - video: &lt;a href=&quot;http://london2011.drupal.org/conference/sessions/code-stinks&quot;&gt;http://london2011.drupal.org/conference/sessions/code-stinks&lt;/a&gt;&lt;br /&gt;
HOWTO: Submit tests with your patch - &lt;a href=&quot;http://groups.drupal.org/node/11020&quot;&gt;http://groups.drupal.org/node/11020&lt;/a&gt;&lt;br /&gt;
Unit Testing with Simpletest - &lt;a href=&quot;http://drupal.org/node/811254&quot;&gt;http://drupal.org/node/811254&lt;/a&gt;&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:543:&quot;&lt;ul&gt;
  &lt;li&gt;a clean checkout of the Drupal code base in which the issue appears (&lt;a href=&quot;http://learndrupal.org/lesson/8daa1222-481d-fc54-a9bf-9d9ccc1ae702&quot;&gt;instructions&lt;/a&gt;)&lt;/li&gt;
  &lt;li&gt;the ability to apply and test patches (&lt;a href=&quot;http://learndrupal.org/lesson/93887717-c398-2434-394c-cf10851b4f1c&quot;&gt;instructions&lt;/a&gt;)&lt;/li&gt;
  &lt;li&gt;at least a beginner-level familiarity with &lt;a href =&quot;http://www.php.net/&quot;&gt;PHP&lt;/a&gt; and the &lt;a href=&quot;http://api.drupal.org/api/drupal&quot;&gt;Drupal API&lt;/a&gt;&lt;/li&gt;
  &lt;li&gt;your favorite note-taking application&lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:528:&quot;&lt;ul&gt;&lt;li&gt;a clean checkout of the Drupal code base in which the issue appears (&lt;a href=&quot;http://learndrupal.org/lesson/8daa1222-481d-fc54-a9bf-9d9ccc1ae702&quot;&gt;instructions&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;the ability to apply and test patches (&lt;a href=&quot;http://learndrupal.org/lesson/93887717-c398-2434-394c-cf10851b4f1c&quot;&gt;instructions&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;at least a beginner-level familiarity with &lt;a href=&quot;http://www.php.net/&quot;&gt;PHP&lt;/a&gt; and the &lt;a href=&quot;http://api.drupal.org/api/drupal&quot;&gt;Drupal API&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;your favorite note-taking application&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:624:&quot;In this lesson you will review and possibly revise a REAL drupal patch currently in the issue queues of drupal.org. You will make notes of your observations during each step of the lesson. You will use these notes to create your Patch Review.

You do NOT need be a drupal expert to review and revise patches. Simply choose a patch that matches your level of ability. Even the smallest, most basic patches need to be reviewed and possibly revised. These include patches that remove extra whitespaces from existing code, patches that correct typos in a function\'s comment, and patches that make very simple code corrections.&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:636:&quot;&lt;p&gt;In this lesson you will review and possibly revise a REAL drupal patch currently in the issue queues of drupal.org. You will make notes of your observations during each step of the lesson. You will use these notes to create your Patch Review.&lt;/p&gt;
&lt;p&gt;You do NOT need be a drupal expert to review and revise patches. Simply choose a patch that matches your level of ability. Even the smallest, most basic patches need to be reviewed and possibly revised. These include patches that remove extra whitespaces from existing code, patches that correct typos in a function\'s comment, and patches that make very simple code corrections.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:75:&quot;Learn to review and revise patches submitted to the drupal.org issue queue.&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:75:&quot;Learn to review and revise patches submitted to the drupal.org issue queue.&quot;;}}}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:13:&quot;not-available&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:0:{}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:2:&quot;27&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1333279609&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:2:&quot;68&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;1&quot;;s:4:&quot;name&quot;;s:12:&quot;ronaldmulero&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;16&quot;;s:6:&quot;source&quot;;s:7:&quot;node/13&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/32c03c97-5fd5-c5d4-497c-9c54a309d557&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:3;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:3:&quot;302&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:51:&quot;Join an issue team to work on an issue in the queue&quot;;s:3:&quot;log&quot;;s:40:&quot;Removing reference to boston initiative.&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;7eb267cc-9c51-7034-1584-b18c7a3ea54c&quot;;s:3:&quot;nid&quot;;s:2:&quot;10&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903142&quot;;s:7:&quot;changed&quot;;s:10:&quot;1347849001&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;683e80f8-11b8-2f64-b985-a97d436c664e&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1347849001&quot;;s:12:&quot;revision_uid&quot;;s:2:&quot;42&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:1597:&quot;&lt;ol&gt;
  &lt;li&gt;Visit the Drupal Ladder &lt;a href=&quot;http://ladder.drupalofficehours.org/&quot;&gt;task tracking tool&lt;/a&gt;, and create an account if you don\'t have one already.&lt;/li&gt;
  &lt;li&gt;Find tasks that have been prepared for your local user group\'s sprint. If you don\'t already know how the organizer tagged tasks, ask him or her what tag to look for. Then, use that tag in the following URL: http://ladder.drupalofficehours.org/tasks/{tag}. For example, the tasks being done by the DC user group might be found at http://ladder.drupalofficehours.org/tasks/dc
  &lt;li&gt;Pick a task with the red &quot;Yes&quot; column at left. This indicates that no one else is already working on the task. Click the title in the Task column to view the task and decide if it\'s one that you can help make some progress on. If so, click the &quot;+ Add&quot; link below the &quot;Task Attemp&quot; header, to indicate that you\'re going to work on the task. Your name will be filled in for the Participant field; just click Save.&lt;/li&gt;
  &lt;li&gt;Next, visit the issue on drupal.org and read the issue and comments to see how far along the task is. You can get to the drupal.org page by clicking on the &lt;strong&gt;d.o nid&lt;/strong&gt; number.
  &lt;li&gt;Reproduce the current state of the issue and see if you can move things forward. If so, certainly post a comments of your own.&lt;/li&gt;
  &lt;li&gt;On the day of the issue queue, pair up with the Mentor listed on your chosen task, and work together to move the issue forward in some way, either by adding new information to the comments, or by testing a patch someone else has posted, or by writing a patch of your own.&lt;/li&gt;
&lt;/ol&gt;
&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:1701:&quot;&lt;ol&gt;&lt;li&gt;Visit the Drupal Ladder &lt;a href=&quot;http://ladder.drupalofficehours.org/&quot;&gt;task tracking tool&lt;/a&gt;, and create an account if you don\'t have one already.&lt;/li&gt;
&lt;li&gt;Find tasks that have been prepared for your local user group\'s sprint. If you don\'t already know how the organizer tagged tasks, ask him or her what tag to look for. Then, use that tag in the following URL: &lt;a href=&quot;http://ladder.drupalofficehours.org/tasks/&quot;&gt;http://ladder.drupalofficehours.org/tasks/&lt;/a&gt;{tag}. For example, the tasks being done by the DC user group might be found at &lt;a href=&quot;http://ladder.drupalofficehours.org/tasks/dc&quot;&gt;http://ladder.drupalofficehours.org/tasks/dc&lt;/a&gt;
&lt;/li&gt;&lt;li&gt;Pick a task with the red &quot;Yes&quot; column at left. This indicates that no one else is already working on the task. Click the title in the Task column to view the task and decide if it\'s one that you can help make some progress on. If so, click the &quot;+ Add&quot; link below the &quot;Task Attemp&quot; header, to indicate that you\'re going to work on the task. Your name will be filled in for the Participant field; just click Save.&lt;/li&gt;
&lt;li&gt;Next, visit the issue on drupal.org and read the issue and comments to see how far along the task is. You can get to the drupal.org page by clicking on the &lt;strong&gt;d.o nid&lt;/strong&gt; number.
&lt;/li&gt;&lt;li&gt;Reproduce the current state of the issue and see if you can move things forward. If so, certainly post a comments of your own.&lt;/li&gt;
&lt;li&gt;On the day of the issue queue, pair up with the Mentor listed on your chosen task, and work together to move the issue forward in some way, either by adding new information to the comments, or by testing a patch someone else has posted, or by writing a patch of your own.&lt;/li&gt;
&lt;/ol&gt;&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:227:&quot;This step can\'t be completed until an issue sprint has been planned for your local user group. If no one else is organizing such a sprint, &lt;a href=&quot;http://drupalladder.org/issue-sprints&quot;&gt;you can start planning one yourself&lt;/a&gt;!&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:235:&quot;&lt;p&gt;This step can\'t be completed until an issue sprint has been planned for your local user group. If no one else is organizing such a sprint, &lt;a href=&quot;http://drupalladder.org/issue-sprints&quot;&gt;you can start planning one yourself&lt;/a&gt;!&lt;/p&gt;
&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:137:&quot;&lt;p&gt;Why not team up on resolving issues? Working as part of a team is more productive, not to mention social, and a good way to learn.&lt;/p&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:138:&quot;&lt;p&gt;Why not team up on resolving issues? Working as part of a team is more productive, not to mention social, and a good way to learn.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:16:&quot;ready-for-review&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1347849001&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;42&quot;;}}}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;121&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1347849001&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:2:&quot;42&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;1&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;13&quot;;s:6:&quot;source&quot;;s:7:&quot;node/10&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/683e80f8-11b8-2f64-b985-a97d436c664e&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:4;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:4:&quot;1053&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:13:&quot;Write a patch&quot;;s:3:&quot;log&quot;;s:99:&quot;Added mention about issue numbers as &quot;fill in the blanks&quot; based on multiple comments from testers. &quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;19cbfebb-9975-e114-59c1-bded0f584895&quot;;s:3:&quot;nid&quot;;s:1:&quot;7&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330902500&quot;;s:7:&quot;changed&quot;;s:10:&quot;1355050055&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;72a836e6-b408-a7a4-1923-8788761b2608&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1355050055&quot;;s:12:&quot;revision_uid&quot;;s:4:&quot;5826&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:5352:&quot;Tip: In the steps treat [things in square brackets] as blanks to fill in. Therefore, replace [issue-numer] with your actual issue number such as [1234]. 

&lt;strong&gt;Create a branch for development&lt;/strong&gt;
&lt;ol&gt;
  &lt;li&gt;Go to your Drupal 8 sandbox.
    &lt;code&gt;cd path/to/drupal-8/sandbox&lt;/code&gt;
  &lt;/li&gt;
    &lt;li&gt;Check what branch you\'re in and make sure you are in 8.x.
    &lt;code&gt;git branch&lt;/code&gt;
  &lt;/li&gt;
    &lt;li&gt;Create a branch where you will work on your patch.
    &lt;code&gt;git branch [issue-number]-rewrite-description-for-url-alias&lt;/code&gt;
  &lt;/li&gt;
    &lt;li&gt;Now check out the branch you just created.
    &lt;code&gt;git checkout [issue-number]-rewrite-description-for-url-alias&lt;/code&gt;
  &lt;/li&gt;
    &lt;li&gt;Confirm you\'re on the branch you just created.
    &lt;code&gt;git branch&lt;/code&gt;
  &lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Make your edits.&lt;/strong&gt;
&lt;ol&gt;
&lt;li&gt;Open the path.module file (e.g. my-sandbox/core/modules/path/path.module) with your favorite text editor.&lt;/li&gt;
&lt;li&gt;Go to line 139 and replace this:
    &lt;code&gt;Optionally specify an alternative URL by which this content can be accessed. For example, type &quot;about&quot; when writing an about page. Use a relative path and don\'t add a trailing slash or the URL alias won\'t work.&lt;/code&gt;
    with this:
    &lt;code&gt;The alternative URL for this content. Use a relative path without a trailing slash. For example, type &quot;about&quot; for the about page.&lt;/code&gt;
  &lt;/li&gt;
  &lt;li&gt; In your browser, go to Content &gt; + Add content &gt; Article (node/add/article), scroll down and click the URL path settings tab. Confirm your edit worked by seeing that the help text as changed, and confirm you didn\'t accidentally introduce an error.&lt;/li&gt;
  &lt;li&gt;Take a screen shot. Using your screenshot program, call out out the changed text with an arrow or highlight. (You will upload this along with your patch.)&lt;/li&gt;
  &lt;li&gt;See which files have changes pending.
     &lt;code&gt;git status&lt;/code&gt;
  &lt;/li&gt;
  &lt;li&gt;Review your changes in Git with a standard diff. (Note to exit the patch display, type the letter &lt;code&gt;q&lt;/code&gt; on your command line to quit viewing.)
    &lt;code&gt;git diff&lt;/code&gt;
     You can also review your changes word-by-word.
   &lt;code&gt;git diff --word-diff&lt;/code&gt;
  &lt;/li&gt;
  &lt;li&gt;If you made a mistake, you can undo all of your changes.
      &lt;code&gt;git reset --hard&lt;/code&gt;
  &lt;/li&gt;
  &lt;li&gt; Commit your changes on your local development branch. The &quot;-am&quot; flag in this command is adding (a) the modified file to the local git repository with the message (m) that you provide being added to the git log.
     &lt;code&gt;git commit -am &quot;Issue #[issue-number]. Updated description for URL alias on node form.&quot;&lt;/code&gt;
     (When you commit your changes, git may generate and display a commit ID. The commit ID is a 40 character code, e.g. bc584d4ff96d434706211e2bef45613dd32d3c16. You can use this ID to refer to and review your commit.)
  &lt;/li&gt;
   &lt;li&gt;Review your commit.
     &lt;code&gt;git log&lt;/code&gt;
     &lt;code&gt;git show&lt;/code&gt;
    Or
     &lt;code&gt; git show [commit ID]&lt;/code&gt;
  &lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Create and submit a patch&lt;/strong&gt;
&lt;ol&gt;
  &lt;li&gt;Figure out which comment number your patch will be attached to. Go to the issue and scroll down through the comments. Note the comment number for the last comment. Your patch will be attached to the next comment, so you will use that next sequential number for your patch. E.g. if the issue has 3 existing comments, your patch will be attached to comment 4. You will use the number 4 as part of your patch name in the next step.&lt;/li&gt;
  &lt;li&gt;Generate a patch file using the following naming convention. Note that the patch filename cannot contain any spaces, so use dashes or underscores to separate words and numbers. This is taking the output of the git diff, which shows the changes between your branch and 8.x, and creating a file with that text, which ends in .patch&lt;/p&gt;
     &lt;code&gt;git diff 8.x &amp;gt; [description]-[issue-number]-[comment-number].patch&lt;/code&gt;
  &lt;/li&gt;
  &lt;li&gt;Go to your issue on Drupal.org.&lt;/li&gt;
  &lt;li&gt;Post a comment on the issue and upload your patch and screenshot.&lt;/li&gt;
  &lt;li&gt;&lt;strong&gt;* Note&lt;/strong&gt;: Normally you would now wait for the testbot to test your patch. This is a sandbox issue queue, so the testbot WILL NOT test your patch here. When you do post in a regular issue queue, the testbot will check your patch to make sure it doesn\'t break anything. If your patch turns green, the patch applied cleanly and passed Drupal\'s tests. Now if your patch passes tests by other members of the community, it can be committed. If your patch turns red, tests failed. Click the link for View details to see what\'s going wrong, then re-write and re-submit your patch. &lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Bonus: Re-roll the patch&lt;/strong&gt;
In the real patch to this issue, &lt;a href=&quot;http://drupal.org/node/1326088#comment-5188202&quot;&gt;http://drupal.org/node/1326088#comment-5188202&lt;/a&gt;, the word \'type\' was changed to \'enter\' before it was finally committed.
&lt;ol&gt;
  &lt;li&gt;Checkout your development branch.
    &lt;code&gt;git checkout my-branch&lt;/code&gt;
  &lt;/li&gt;
    &lt;li&gt;Make your edit, by changing the word \'type\' to \'enter.\'&lt;/li&gt;
    &lt;li&gt;Commit.
     &lt;code&gt;git commit -am &amp;quot;Issue #[issue-number]. [Description].&quot;&lt;/code&gt;
  &lt;/li&gt;
    &lt;li&gt;Create a new patch with the updates.
     &lt;code&gt;git diff 8.x &amp;gt; [description]-[issue-number]-[comment-number].patch&lt;/code&gt;
  &lt;/li&gt;
&lt;/ol&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:5278:&quot;&lt;p&gt;Tip: In the steps treat [things in square brackets] as blanks to fill in. Therefore, replace [issue-numer] with your actual issue number such as [1234]. &lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Create a branch for development&lt;/strong&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Go to your Drupal 8 sandbox.&lt;br /&gt;&lt;code&gt;cd path/to/drupal-8/sandbox&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Check what branch you\'re in and make sure you are in 8.x.&lt;br /&gt;&lt;code&gt;git branch&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Create a branch where you will work on your patch.&lt;br /&gt;&lt;code&gt;git branch [issue-number]-rewrite-description-for-url-alias&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Now check out the branch you just created.&lt;br /&gt;&lt;code&gt;git checkout [issue-number]-rewrite-description-for-url-alias&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Confirm you\'re on the branch you just created.&lt;br /&gt;&lt;code&gt;git branch&lt;/code&gt;
  &lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Make your edits.&lt;/strong&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Open the path.module file (e.g. my-sandbox/core/modules/path/path.module) with your favorite text editor.&lt;/li&gt;
&lt;li&gt;Go to line 139 and replace this:&lt;br /&gt;&lt;code&gt;Optionally specify an alternative URL by which this content can be accessed. For example, type &quot;about&quot; when writing an about page. Use a relative path and don\'t add a trailing slash or the URL alias won\'t work.&lt;/code&gt;&lt;br /&gt;
    with this:&lt;br /&gt;&lt;code&gt;The alternative URL for this content. Use a relative path without a trailing slash. For example, type &quot;about&quot; for the about page.&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt; In your browser, go to Content &amp;gt; + Add content &amp;gt; Article (node/add/article), scroll down and click the URL path settings tab. Confirm your edit worked by seeing that the help text as changed, and confirm you didn\'t accidentally introduce an error.&lt;/li&gt;
&lt;li&gt;Take a screen shot. Using your screenshot program, call out out the changed text with an arrow or highlight. (You will upload this along with your patch.)&lt;/li&gt;
&lt;li&gt;See which files have changes pending.&lt;br /&gt;&lt;code&gt;git status&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Review your changes in Git with a standard diff. (Note to exit the patch display, type the letter &lt;code&gt;q&lt;/code&gt; on your command line to quit viewing.)&lt;br /&gt;&lt;code&gt;git diff&lt;/code&gt;&lt;br /&gt;
     You can also review your changes word-by-word.&lt;br /&gt;&lt;code&gt;git diff --word-diff&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;If you made a mistake, you can undo all of your changes.&lt;br /&gt;&lt;code&gt;git reset --hard&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt; Commit your changes on your local development branch. The &quot;-am&quot; flag in this command is adding (a) the modified file to the local git repository with the message (m) that you provide being added to the git log.&lt;br /&gt;&lt;code&gt;git commit -am &quot;Issue #[issue-number]. Updated description for URL alias on node form.&quot;&lt;/code&gt;&lt;br /&gt;
     (When you commit your changes, git may generate and display a commit ID. The commit ID is a 40 character code, e.g. bc584d4ff96d434706211e2bef45613dd32d3c16. You can use this ID to refer to and review your commit.)
  &lt;/li&gt;
&lt;li&gt;Review your commit.&lt;br /&gt;&lt;code&gt;git log&lt;/code&gt;&lt;br /&gt;&lt;code&gt;git show&lt;/code&gt;&lt;br /&gt;
    Or&lt;br /&gt;&lt;code&gt; git show [commit ID]&lt;/code&gt;
  &lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Create and submit a patch&lt;/strong&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Figure out which comment number your patch will be attached to. Go to the issue and scroll down through the comments. Note the comment number for the last comment. Your patch will be attached to the next comment, so you will use that next sequential number for your patch. E.g. if the issue has 3 existing comments, your patch will be attached to comment 4. You will use the number 4 as part of your patch name in the next step.&lt;/li&gt;
&lt;li&gt;Generate a patch file using the following naming convention. Note that the patch filename cannot contain any spaces, so use dashes or underscores to separate words and numbers. This is taking the output of the git diff, which shows the changes between your branch and 8.x, and creating a file with that text, which ends in .patch&lt;br /&gt;&lt;code&gt;git diff 8.x &amp;gt; [description]-[issue-number]-[comment-number].patch&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Go to your issue on Drupal.org.&lt;/li&gt;
&lt;li&gt;Post a comment on the issue and upload your patch and screenshot.&lt;/li&gt;
&lt;li&gt;&lt;strong&gt;* Note&lt;/strong&gt;: Normally you would now wait for the testbot to test your patch. This is a sandbox issue queue, so the testbot WILL NOT test your patch here. When you do post in a regular issue queue, the testbot will check your patch to make sure it doesn\'t break anything. If your patch turns green, the patch applied cleanly and passed Drupal\'s tests. Now if your patch passes tests by other members of the community, it can be committed. If your patch turns red, tests failed. Click the link for View details to see what\'s going wrong, then re-write and re-submit your patch. &lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Bonus: Re-roll the patch&lt;/strong&gt;&lt;br /&gt;
In the real patch to this issue, &lt;a href=&quot;http://drupal.org/node/1326088#comment-5188202&quot;&gt;http://drupal.org/node/1326088#comment-5188202&lt;/a&gt;, the word \'type\' was changed to \'enter\' before it was finally committed.&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Checkout your development branch.&lt;br /&gt;&lt;code&gt;git checkout my-branch&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Make your edit, by changing the word \'type\' to \'enter.\'&lt;/li&gt;
&lt;li&gt;Commit.&lt;br /&gt;&lt;code&gt;git commit -am &quot;Issue #[issue-number]. [Description].&quot;&lt;/code&gt;
  &lt;/li&gt;
&lt;li&gt;Create a new patch with the updates.&lt;br /&gt;&lt;code&gt;git diff 8.x &amp;gt; [description]-[issue-number]-[comment-number].patch&lt;/code&gt;
  &lt;/li&gt;
&lt;/ol&gt;&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:1:{s:3:&quot;und&quot;;a:3:{i:0;a:1:{s:5:&quot;value&quot;;s:1:&quot;6&quot;;}i:1;a:1:{s:5:&quot;value&quot;;s:1:&quot;7&quot;;}i:2;a:1:{s:5:&quot;value&quot;;s:1:&quot;8&quot;;}}}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:4:&quot;core&quot;;}}}s:17:&quot;field_lesson_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:4:&quot;code&quot;;}}}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:1404:&quot;&lt;ul&gt;
&lt;li&gt;You\'ll be working with a sandbox version of Drupal in this exercise. It has been built with a known issue for you to patch. For this lesson, download and install Drupal 8 from the &lt;a href=&quot;http://drupal.org/project/1388780/git-instructions&quot;&gt;Drupal 8 Sandbox for Drupal Ladder&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;http://drupalladder.org/lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;&gt;Install Git&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;An issue in the sandbox issue queue, as created in the &lt;a href=&quot;http://learndrupal.org/lesson/1d498fa2-d3e4-5754-9160-757d219e8032&quot;&gt;Getting started in the issue queue&lt;/a&gt; lesson. You will need to know your issue number, which is the node ID for the issue on Drupal.org. You can easily find this by going to the issue page and then selecting the node ID from the page URL. E.g. if the issue page URL is http://drupal.org/node/1681300, the node ID, and therefore the issue ID is 1681300. Make note of this for reference in this lesson.&lt;/li&gt;
&lt;li&gt;Basic Git knowledge is helpful but not required (&lt;a href=&quot;http://learn.github.com/p/intro.html&quot;&gt;Intro to Git&lt;/a&gt;, &lt;a href=&quot;http://gitref.org/&quot;&gt;Git Reference&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;A way to capture screen shots. Popular options include: &lt;a href=&quot;http://skitch.com/&quot; title=&quot;Skitch&quot;&gt;Skitch&lt;/a&gt;, &lt;a href=&quot;http://www.techsmith.com/jing.html&quot; title=&quot;Jing&quot;&gt;Jing&lt;/a&gt;, or &lt;a href=&quot;http://awesomescreenshot.com/&quot; title=&quot;Awesome Screenshot&quot;&gt;Awesome Screenshot&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:1442:&quot;&lt;ul&gt;&lt;li&gt;You\'ll be working with a sandbox version of Drupal in this exercise. It has been built with a known issue for you to patch. For this lesson, download and install Drupal 8 from the &lt;a href=&quot;http://drupal.org/project/1388780/git-instructions&quot;&gt;Drupal 8 Sandbox for Drupal Ladder&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;http://drupalladder.org/lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;&gt;Install Git&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;An issue in the sandbox issue queue, as created in the &lt;a href=&quot;http://learndrupal.org/lesson/1d498fa2-d3e4-5754-9160-757d219e8032&quot;&gt;Getting started in the issue queue&lt;/a&gt; lesson. You will need to know your issue number, which is the node ID for the issue on Drupal.org. You can easily find this by going to the issue page and then selecting the node ID from the page URL. E.g. if the issue page URL is &lt;a href=&quot;http://drupal.org/node/1681300&quot;&gt;http://drupal.org/node/1681300&lt;/a&gt;, the node ID, and therefore the issue ID is 1681300. Make note of this for reference in this lesson.&lt;/li&gt;
&lt;li&gt;Basic Git knowledge is helpful but not required (&lt;a href=&quot;http://learn.github.com/p/intro.html&quot;&gt;Intro to Git&lt;/a&gt;, &lt;a href=&quot;http://gitref.org/&quot;&gt;Git Reference&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;A way to capture screen shots. Popular options include: &lt;a href=&quot;http://skitch.com/&quot; title=&quot;Skitch&quot;&gt;Skitch&lt;/a&gt;, &lt;a href=&quot;http://www.techsmith.com/jing.html&quot; title=&quot;Jing&quot;&gt;Jing&lt;/a&gt;, or &lt;a href=&quot;http://awesomescreenshot.com/&quot; title=&quot;Awesome Screenshot&quot;&gt;Awesome Screenshot&lt;/a&gt;&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:464:&quot;&lt;p&gt;In this exercise you will create a patch to resolve the issue created in the previous exercise. Then you will post this patch along with before and after screen shots as a proposed solution to the issue.&lt;/p&gt;
&lt;p&gt;Currently, this tutorial only has instructions for working with Git on the command line.&lt;/p&gt;

&lt;strong&gt;Resources&lt;/strong&gt;
There is a short video, &lt;a href=&quot;http://drupalize.me/videos/write-patch&quot;&gt;Writing a patch&lt;/a&gt;, that walks through this lesson.&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:472:&quot;&lt;p&gt;In this exercise you will create a patch to resolve the issue created in the previous exercise. Then you will post this patch along with before and after screen shots as a proposed solution to the issue.&lt;br /&gt;
Currently, this tutorial only has instructions for working with Git on the command line.&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Resources&lt;/strong&gt;&lt;br /&gt;
There is a short video, &lt;a href=&quot;http://drupalize.me/videos/write-patch&quot;&gt;Writing a patch&lt;/a&gt;, that walks through this lesson.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:58:&quot;Learn to submit suggested changes to Drupal as patch files&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:58:&quot;Learn to submit suggested changes to Drupal as patch files&quot;;}}}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:14:&quot;needs-revision&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1355050055&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;196&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1355050055&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:4:&quot;5826&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;2&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;10&quot;;s:6:&quot;source&quot;;s:6:&quot;node/7&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/72a836e6-b408-a7a4-1923-8788761b2608&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:5;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:3:&quot;224&quot;;s:3:&quot;uid&quot;;s:2:&quot;18&quot;;s:5:&quot;title&quot;;s:22:&quot;Install Drupal locally&quot;;s:3:&quot;log&quot;;s:19:&quot;added link to video&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;9c8ddea5-7113-c024-01fa-56b0a7cf1d58&quot;;s:3:&quot;nid&quot;;s:1:&quot;9&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903063&quot;;s:7:&quot;changed&quot;;s:10:&quot;1354956390&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;8daa1222-481d-fc54-a9bf-9d9ccc1ae702&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1354956390&quot;;s:12:&quot;revision_uid&quot;;s:2:&quot;38&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:1039:&quot;This lesson has 3 sections:
&lt;ol&gt;
&lt;li&gt;&lt;a href=&quot;/lesson/b382d210-5815-ce84-6d4e-4aad245548d6&quot;&gt;Install Dev Desktop&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;/lesson/2d3d812b-c313-9ff4-517c-ee28993916c4&quot;&gt;Download Drupal 8&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;/lesson/3e6d7e33-33bc-d704-7189-e331a0d80c87&quot;&gt;Launch Drupal 8 on Dev Desktop&lt;/a&gt;&lt;/li&gt;
&lt;/ol&gt;

Note that these instructions use Dev Desktop, but there are other all-in-one web servers you can use, notably &lt;a href=&quot;http://mamp.info&quot;&gt;MAMP&lt;/a&gt; for Mac and &lt;a href=&quot;http://www.wampserver.com/en/&quot;&gt;WAMP&lt;/a&gt; for Windows. On Linux you will need to install a web server based on the distro you are using. If you would like to have an entire virtual machine instance, with lots of other web server goodies, you can check out &lt;a href=&quot;http://drupal.org/project/drupalpro&quot;&gt;Drupal Pro&lt;/a&gt; or &lt;a href=&quot;http://drupal.org/project/quickstart&quot;&gt;Drupal Quickstart&lt;/a&gt;.

If you have a web server already, you can follow these instructions from section 2: &lt;a href=&quot;/lesson/2d3d812b-c313-9ff4-517c-ee28993916c4&quot;&gt;Download Drupal 8&lt;/a&gt;.&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:1048:&quot;&lt;p&gt;This lesson has 3 sections:&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;&lt;a href=&quot;/lesson/b382d210-5815-ce84-6d4e-4aad245548d6&quot;&gt;Install Dev Desktop&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;/lesson/2d3d812b-c313-9ff4-517c-ee28993916c4&quot;&gt;Download Drupal 8&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;/lesson/3e6d7e33-33bc-d704-7189-e331a0d80c87&quot;&gt;Launch Drupal 8 on Dev Desktop&lt;/a&gt;&lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;Note that these instructions use Dev Desktop, but there are other all-in-one web servers you can use, notably &lt;a href=&quot;http://mamp.info&quot;&gt;MAMP&lt;/a&gt; for Mac and &lt;a href=&quot;http://www.wampserver.com/en/&quot;&gt;WAMP&lt;/a&gt; for Windows. On Linux you will need to install a web server based on the distro you are using. If you would like to have an entire virtual machine instance, with lots of other web server goodies, you can check out &lt;a href=&quot;http://drupal.org/project/drupalpro&quot;&gt;Drupal Pro&lt;/a&gt; or &lt;a href=&quot;http://drupal.org/project/quickstart&quot;&gt;Drupal Quickstart&lt;/a&gt;.&lt;/p&gt;
&lt;p&gt;If you have a web server already, you can follow these instructions from section 2: &lt;a href=&quot;/lesson/2d3d812b-c313-9ff4-517c-ee28993916c4&quot;&gt;Download Drupal 8&lt;/a&gt;.&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:276:&quot;This lesson assumes access to a computer with a Mac or Windows OS. If you are on Linux, you can install a web server appropriate to your distro. You can watch a video on &lt;a href=&quot;http://drupalize.me/videos/installing-web-server-ubuntu&quot;&gt;installing a web server on Ubuntu&lt;/a&gt;.
&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:282:&quot;&lt;p&gt;This lesson assumes access to a computer with a Mac or Windows OS. If you are on Linux, you can install a web server appropriate to your distro. You can watch a video on &lt;a href=&quot;http://drupalize.me/videos/installing-web-server-ubuntu&quot;&gt;installing a web server on Ubuntu&lt;/a&gt;.&lt;/p&gt;
&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:450:&quot;Downloading Drupal locally provides a safe place to experiment with code without affecting a live site or exposing confidential site data to others. This lesson will set up a local web server on a computer, and install Drupal on that web server.

&lt;strong&gt;Resources:&lt;/strong&gt;
There is a short video, &lt;a href=&quot;http://drupalize.me/videos/install-drupal-locally-dev-desktop&quot;&gt;Install Drupal Locally with Dev Desktop&lt;/a&gt;, that walks through this lesson.&quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:467:&quot;&lt;p&gt;Downloading Drupal locally provides a safe place to experiment with code without affecting a live site or exposing confidential site data to others. This lesson will set up a local web server on a computer, and install Drupal on that web server.&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Resources:&lt;/strong&gt;&lt;br /&gt;
There is a short video, &lt;a href=&quot;http://drupalize.me/videos/install-drupal-locally-dev-desktop&quot;&gt;Install Drupal Locally with Dev Desktop&lt;/a&gt;, that walks through this lesson.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:16:&quot;ready-for-review&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1354956390&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;206&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1355146092&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:4:&quot;2114&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;6&quot;;s:4:&quot;name&quot;;s:7:&quot;MetsArt&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;12&quot;;s:6:&quot;source&quot;;s:6:&quot;node/9&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/8daa1222-481d-fc54-a9bf-9d9ccc1ae702&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:6;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:2:&quot;11&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:53:&quot;Create an issue team to work on an issue in the queue&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;19f4ef50-2371-2b44-ed0b-7eee0fdcd306&quot;;s:3:&quot;nid&quot;;s:2:&quot;11&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903214&quot;;s:7:&quot;changed&quot;;s:10:&quot;1347849409&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;91729e89-5c3a-8e44-bd90-38b1124fc4d1&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1347849409&quot;;s:12:&quot;revision_uid&quot;;s:2:&quot;42&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:1156:&quot;&lt;ol&gt;
  &lt;li&gt;Find a Drupal 8 core issue you would like to work on.&lt;/li&gt;
  &lt;li&gt;Visit the Drupal Ladder &lt;a href=&quot;http://ladder.drupalofficehours.org/&quot;&gt;task tracking tool&lt;/a&gt;, and create an account if you don\'t have one already. Add a new task for the core issue you found.&lt;/li&gt;
  &lt;li&gt;On the new task you created, click the &quot;+ Add&quot; link below the &quot;Task Attemp&quot; header, to indicate that you\'re going to work on the task. Put your user name in the Mentor field and click Save.&lt;/li&gt;
  &lt;li&gt;Jump in and see if you can reproduce the issue.&lt;/li&gt;
  &lt;li&gt;Post a comment to the issue with your results (for example, &amp;quot;I\'m able to reproduce this issue; now checking xyz&amp;quot;). Also be sure to update the issue summary if you discover additional information.&lt;/li&gt;
  &lt;li&gt;During the issue sprint with your user group, meet up with the person who signed up as the Participant for your task. Pair up and work together on the issue.&lt;/li&gt;
  &lt;li&gt;Back in the issue tracker tool, leave comments indicating what you did. This can be pretty simple, such as: &quot;left a comment on the issue with additional debugging information&quot; or &quot;reviewed a patch and left feedback.&quot;
&lt;/ol&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:1128:&quot;&lt;ol&gt;&lt;li&gt;Find a Drupal 8 core issue you would like to work on.&lt;/li&gt;
&lt;li&gt;Visit the Drupal Ladder &lt;a href=&quot;http://ladder.drupalofficehours.org/&quot;&gt;task tracking tool&lt;/a&gt;, and create an account if you don\'t have one already. Add a new task for the core issue you found.&lt;/li&gt;
&lt;li&gt;On the new task you created, click the &quot;+ Add&quot; link below the &quot;Task Attemp&quot; header, to indicate that you\'re going to work on the task. Put your user name in the Mentor field and click Save.&lt;/li&gt;
&lt;li&gt;Jump in and see if you can reproduce the issue.&lt;/li&gt;
&lt;li&gt;Post a comment to the issue with your results (for example, &quot;I\'m able to reproduce this issue; now checking xyz&quot;). Also be sure to update the issue summary if you discover additional information.&lt;/li&gt;
&lt;li&gt;During the issue sprint with your user group, meet up with the person who signed up as the Participant for your task. Pair up and work together on the issue.&lt;/li&gt;
&lt;li&gt;Back in the issue tracker tool, leave comments indicating what you did. This can be pretty simple, such as: &quot;left a comment on the issue with additional debugging information&quot; or &quot;reviewed a patch and left feedback.&quot;
&lt;/li&gt;&lt;/ol&gt;&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:227:&quot;This step can\'t be completed until an issue sprint has been planned for your local user group. If no one else is organizing such a sprint, &lt;a href=&quot;http://drupalladder.org/issue-sprints&quot;&gt;you can start planning one yourself&lt;/a&gt;!&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:235:&quot;&lt;p&gt;This step can\'t be completed until an issue sprint has been planned for your local user group. If no one else is organizing such a sprint, &lt;a href=&quot;http://drupalladder.org/issue-sprints&quot;&gt;you can start planning one yourself&lt;/a&gt;!&lt;/p&gt;
&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:0:{}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:16:&quot;ready-for-review&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1347849409&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;122&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1347849409&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:2:&quot;42&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;1&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;14&quot;;s:6:&quot;source&quot;;s:7:&quot;node/11&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/91729e89-5c3a-8e44-bd90-38b1124fc4d1&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:7;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:4:&quot;1050&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:12:&quot;Test patches&quot;;s:3:&quot;log&quot;;s:65:&quot;Changed boston init sandbox to Drupal 8 Sandbox for Drupal Ladder&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;c7baa874-c540-7af4-0dae-110fed927a87&quot;;s:3:&quot;nid&quot;;s:1:&quot;6&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330902368&quot;;s:7:&quot;changed&quot;;s:10:&quot;1352756085&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;93887717-c398-2434-394c-cf10851b4f1c&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1352756085&quot;;s:12:&quot;revision_uid&quot;;s:2:&quot;68&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:4350:&quot;Before you begin, you can optionally run a few Git configuration commands to make Git more legible. You only need to do this once, and the options will be saved in your .gitconfig file. Open a terminal and type the following commands:
        &lt;code&gt;git config --global color.status auto &lt;/code&gt;
        &lt;code&gt;git config --global color.branch auto &lt;/code&gt;
        &lt;code&gt;git config --global color.interactive auto &lt;/code&gt;
        &lt;code&gt;git config --global color.diff auto&lt;/code&gt;

&lt;ol&gt;
    &lt;li&gt;Using the command line, move into the Drupal 8 sandbox you have cloned if you are not already there, e.g. &lt;code&gt;$ cd path/to/drupal-8/sandbox&lt;/code&gt;.&lt;/li&gt;
    &lt;li&gt;Check which branch you are on with &lt;code&gt;$ git branch&lt;/code&gt;&lt;/li&gt;
    &lt;li&gt;If there\'s not an asterisk next to 8.x, you need to check out 8.x with &lt;code&gt;$ git checkout 8.x&lt;/code&gt;&lt;/li&gt;
     &lt;li&gt;Review the &lt;a href=&quot;http://drupal.org/node/1388832&quot;&gt;example issue on Drupal.org&lt;/a&gt; and find this problem in your locally installed sandbox site. (This is the sandbox issue that the lesson, &lt;a href=&quot;http://learndrupal.org/lesson/1d498fa2-d3e4-5754-9160-757d219e8032&quot;&gt;Getting started in the issue queue&lt;/a&gt; is using. You can also read the &lt;a href=&quot;http://drupal.org/node/1326088&quot;&gt;real original issue for Drupal core&lt;/a&gt;.) You can read the patch by clicking on the patch file and opening it in your browser, or by opening it in a text editor after you have downloaded it.&lt;/li&gt;
    &lt;li&gt;Download the &lt;a href=&quot;http://drupal.org/node/1388832#comment-5948668&quot;&gt;patch in comment 2&lt;/a&gt;, which is the latest patch. You should place it in your local sandbox root directory. (Note: make sure that the file ends with .patch and not .txt. Some operating systems will append the .txt extension, so double-check it and correct it, if so.)&lt;/li&gt;
    &lt;li&gt;In your sandbox site, go to the page where the changes will take effect by going to Content &gt; + Add content &gt; Article (node/add/article), and then scrolling down and clicking the URL path settings tab. The help text for that setting is what will be changing with the patch.&lt;/li&gt;
    &lt;li&gt;Make sure you are in your sandbox root directory, where the patch file is located, and apply the patch by using the command &lt;code&gt;git apply 1326088-rewrite-desription-for-url-alias.patch&lt;/code&gt;&lt;/li&gt;
    &lt;li&gt;Refresh the page in your local sandbox site you have open in your browser (the node/add/* page) and confirm the issue has been resolved by seeing the help text change.&lt;/li&gt;
    &lt;li&gt;If you were working on a real issue, you would now post a comment saying you have applied and tested the patch, and it resolves the problem.&lt;/li&gt;
    &lt;li&gt;Once done testing, undo the changes applied by the patch with &lt;code&gt;$ git reset --hard&lt;/code&gt; &lt;/li&gt;
&lt;/ol&gt;

&lt;strong&gt;Tips for testing more complex patches:&lt;/strong&gt;
&lt;ul&gt;
  &lt;li&gt;If your patch applies cleanly, but doesn\'t seem to work, try clearing your cache.&lt;/li&gt;
  &lt;li&gt;If clearing the cache doesn\'t work, check to see if the patch you applied requires database updates.
  Database updates are located in .install files. You can see the files modified by the patch with &lt;code&gt;$ git show --stat&lt;/code&gt;. Git will display a list of filenames with pluses and minuses, as shown in the picture below.
&lt;img style=&quot;max-width:638px&quot; src=&quot;https://img.skitch.com/20111002-gpjwbk7he9bagdupamw6g39wj2.medium.jpg&quot; alt=&quot;Terminal 2014 less 2014 106ձ6&quot; /&gt;

  &lt;/li&gt;
  &lt;li&gt;If an .install file was modified, run update.php by going to http://example.com/update.php &lt;/li&gt;
  &lt;li&gt;If you want to save a copy of your patched version of Drupal to continue working on this issue later, create a new branch and then commit the changes there. To do this, after applying the patch run the following commands: 
    &lt;code&gt;$ git checkout -b [issue-number]-[description] &lt;/code&gt;
    &lt;code&gt;$ git commit -m \'Applying [patchname.patch] from http://drupal.org/node/[issue-number]-[comment-number]\'&lt;/code&gt;
&lt;li&gt;To see your branches do this: &lt;code&gt;$ git branch&lt;/code&gt;&lt;/li&gt;
  &lt;li&gt;Now you can switch back and forth between Drupal\'s development branch (e.g. 8.x) and your own patched branch like this: 
    &lt;ul&gt;
      &lt;li&gt;see available branches: &lt;code&gt;$ git branch&lt;/code&gt;&lt;/li&gt;
      &lt;li&gt;check out out branch 8.x &lt;code&gt;$ git checkout 8.x&lt;/code&gt;&lt;/li&gt;
      &lt;li&gt;check out your own branch: &lt;code&gt;$ git checkout [name]&lt;/code&gt;&lt;/li&gt;
    &lt;ul&gt;
  &lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:4299:&quot;&lt;p&gt;Before you begin, you can optionally run a few Git configuration commands to make Git more legible. You only need to do this once, and the options will be saved in your .gitconfig file. Open a terminal and type the following commands:&lt;br /&gt;&lt;code&gt;git config --global color.status auto &lt;/code&gt;&lt;br /&gt;&lt;code&gt;git config --global color.branch auto &lt;/code&gt;&lt;br /&gt;&lt;code&gt;git config --global color.interactive auto &lt;/code&gt;&lt;br /&gt;&lt;code&gt;git config --global color.diff auto&lt;/code&gt;&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Using the command line, move into the Drupal 8 sandbox you have cloned if you are not already there, e.g. &lt;code&gt;$ cd path/to/drupal-8/sandbox&lt;/code&gt;.&lt;/li&gt;
&lt;li&gt;Check which branch you are on with &lt;code&gt;$ git branch&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;If there\'s not an asterisk next to 8.x, you need to check out 8.x with &lt;code&gt;$ git checkout 8.x&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;Review the &lt;a href=&quot;http://drupal.org/node/1388832&quot;&gt;example issue on Drupal.org&lt;/a&gt; and find this problem in your locally installed sandbox site. (This is the sandbox issue that the lesson, &lt;a href=&quot;http://learndrupal.org/lesson/1d498fa2-d3e4-5754-9160-757d219e8032&quot;&gt;Getting started in the issue queue&lt;/a&gt; is using. You can also read the &lt;a href=&quot;http://drupal.org/node/1326088&quot;&gt;real original issue for Drupal core&lt;/a&gt;.) You can read the patch by clicking on the patch file and opening it in your browser, or by opening it in a text editor after you have downloaded it.&lt;/li&gt;
&lt;li&gt;Download the &lt;a href=&quot;http://drupal.org/node/1388832#comment-5948668&quot;&gt;patch in comment 2&lt;/a&gt;, which is the latest patch. You should place it in your local sandbox root directory. (Note: make sure that the file ends with .patch and not .txt. Some operating systems will append the .txt extension, so double-check it and correct it, if so.)&lt;/li&gt;
&lt;li&gt;In your sandbox site, go to the page where the changes will take effect by going to Content &amp;gt; + Add content &amp;gt; Article (node/add/article), and then scrolling down and clicking the URL path settings tab. The help text for that setting is what will be changing with the patch.&lt;/li&gt;
&lt;li&gt;Make sure you are in your sandbox root directory, where the patch file is located, and apply the patch by using the command &lt;code&gt;git apply 1326088-rewrite-desription-for-url-alias.patch&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;Refresh the page in your local sandbox site you have open in your browser (the node/add/* page) and confirm the issue has been resolved by seeing the help text change.&lt;/li&gt;
&lt;li&gt;If you were working on a real issue, you would now post a comment saying you have applied and tested the patch, and it resolves the problem.&lt;/li&gt;
&lt;li&gt;Once done testing, undo the changes applied by the patch with &lt;code&gt;$ git reset --hard&lt;/code&gt; &lt;/li&gt;
&lt;/ol&gt;&lt;p&gt;&lt;strong&gt;Tips for testing more complex patches:&lt;/strong&gt;&lt;/p&gt;
&lt;ul&gt;&lt;li&gt;If your patch applies cleanly, but doesn\'t seem to work, try clearing your cache.&lt;/li&gt;
&lt;li&gt;If clearing the cache doesn\'t work, check to see if the patch you applied requires database updates.&lt;br /&gt;
  Database updates are located in .install files. You can see the files modified by the patch with &lt;code&gt;$ git show --stat&lt;/code&gt;. Git will display a list of filenames with pluses and minuses, as shown in the picture below.&lt;br /&gt;&lt;img style=&quot;max-width:638px&quot; src=&quot;https://img.skitch.com/20111002-gpjwbk7he9bagdupamw6g39wj2.medium.jpg&quot; alt=&quot;Terminal 2014 less 2014 106ձ6&quot; /&gt;&lt;/li&gt;
&lt;li&gt;If an .install file was modified, run update.php by going to &lt;a href=&quot;http://example.com/update.php&quot;&gt;http://example.com/update.php&lt;/a&gt; &lt;/li&gt;
&lt;li&gt;If you want to save a copy of your patched version of Drupal to continue working on this issue later, create a new branch and then commit the changes there. To do this, after applying the patch run the following commands:&lt;br /&gt;&lt;code&gt;$ git checkout -b [issue-number]-[description] &lt;/code&gt;&lt;br /&gt;&lt;code&gt;$ git commit -m \'Applying [patchname.patch] from http://drupal.org/node/[issue-number]-[comment-number]\'&lt;/code&gt;
&lt;/li&gt;&lt;li&gt;To see your branches do this: &lt;code&gt;$ git branch&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;Now you can switch back and forth between Drupal\'s development branch (e.g. 8.x) and your own patched branch like this:
&lt;ul&gt;&lt;li&gt;see available branches: &lt;code&gt;$ git branch&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;check out out branch 8.x &lt;code&gt;$ git checkout 8.x&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;check out your own branch: &lt;code&gt;$ git checkout [name]&lt;/code&gt;&lt;/li&gt;
&lt;ul&gt;&lt;/ul&gt;&lt;/ul&gt;&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:4:&quot;core&quot;;}}}s:17:&quot;field_lesson_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:4:&quot;code&quot;;}}}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:627:&quot;&lt;ul&gt;
&lt;li&gt;You\'ll be working with a sandbox version of Drupal in this exercise. It has been built with a known issue for you to observe. For this lesson, download and install Drupal 8 from the &lt;a href=&quot;http://drupal.org/project/1388780/git-instructions&quot;&gt;Drupal 8 Sandbox for Drupal Ladder&lt;/a&gt;, using the knowledge from the previous lessons.&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;http://drupalladder.org/lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;&gt;Install Git&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;Basic Git knowledge is helpful but not required (&lt;a href=&quot;http://learn.github.com/p/intro.html&quot;&gt;Intro to Git&lt;/a&gt;, &lt;a href=&quot;http://gitref.org/&quot;&gt;Git Reference&lt;/a&gt;)&lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:622:&quot;&lt;ul&gt;&lt;li&gt;You\'ll be working with a sandbox version of Drupal in this exercise. It has been built with a known issue for you to observe. For this lesson, download and install Drupal 8 from the &lt;a href=&quot;http://drupal.org/project/1388780/git-instructions&quot;&gt;Drupal 8 Sandbox for Drupal Ladder&lt;/a&gt;, using the knowledge from the previous lessons.&lt;/li&gt;
&lt;li&gt;&lt;a href=&quot;http://drupalladder.org/lesson/027b5839-7a74-af04-6905-fee2d01c7ef4&quot;&gt;Install Git&lt;/a&gt;&lt;/li&gt;
&lt;li&gt;Basic Git knowledge is helpful but not required (&lt;a href=&quot;http://learn.github.com/p/intro.html&quot;&gt;Intro to Git&lt;/a&gt;, &lt;a href=&quot;http://gitref.org/&quot;&gt;Git Reference&lt;/a&gt;)&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:738:&quot;&lt;p&gt;In this lesson you will apply a patch that was submitted to resolve a reported issue (the issue has since been resolved; this lesson is for your practice).&lt;/p&gt;
&lt;p&gt;After you get some practice, look in the Drupal 8 issue queue for patches that need review. Before patches get committed they must be reviewed and tested by members of the community. Testing patches is an easy way to help project maintainers resolve issues in the queue, and it doesn\'t require writing any code. You just need to understand the problem and know if it is resolved after the patch has been applied.&lt;/p&gt;

&lt;strong&gt;Resources&lt;/strong&gt;
There is a short video, &lt;a href=&quot;http://drupalize.me/videos/test-patches&quot;&gt;Test patches&lt;/a&gt;, that walks through this lesson.&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:746:&quot;&lt;p&gt;In this lesson you will apply a patch that was submitted to resolve a reported issue (the issue has since been resolved; this lesson is for your practice).&lt;br /&gt;
After you get some practice, look in the Drupal 8 issue queue for patches that need review. Before patches get committed they must be reviewed and tested by members of the community. Testing patches is an easy way to help project maintainers resolve issues in the queue, and it doesn\'t require writing any code. You just need to understand the problem and know if it is resolved after the patch has been applied.&lt;/p&gt;
&lt;p&gt;&lt;strong&gt;Resources&lt;/strong&gt;&lt;br /&gt;
There is a short video, &lt;a href=&quot;http://drupalize.me/videos/test-patches&quot;&gt;Test patches&lt;/a&gt;, that walks through this lesson.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:64:&quot;Test patches submitted to drupal.org for issues awaiting review.&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:64:&quot;Test patches submitted to drupal.org for issues awaiting review.&quot;;}}}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;up-to-date&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1347400919&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;143&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1349534527&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:4:&quot;4957&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;2&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:1:&quot;9&quot;;s:6:&quot;source&quot;;s:6:&quot;node/6&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/93887717-c398-2434-394c-cf10851b4f1c&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:8;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:2:&quot;14&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:30:&quot;Help maintain a core component&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;30c8af7c-1cd0-7814-15c8-59e0eb4e1772&quot;;s:3:&quot;nid&quot;;s:2:&quot;14&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903325&quot;;s:7:&quot;changed&quot;;s:10:&quot;1344940747&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;a3f18dbc-46e3-22f4-fd82-8116c3c57bf8&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1344940747&quot;;s:12:&quot;revision_uid&quot;;s:1:&quot;1&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:36:&quot;This lesson has not been written yet&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:44:&quot;&lt;p&gt;This lesson has not been written yet&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:0:{}s:21:&quot;field_lesson_overview&quot;;a:0:{}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;draft&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:0:{}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:1:&quot;0&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1330903325&quot;;s:17:&quot;last_comment_name&quot;;N;s:16:&quot;last_comment_uid&quot;;s:1:&quot;1&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;0&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;17&quot;;s:6:&quot;source&quot;;s:7:&quot;node/14&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/a3f18dbc-46e3-22f4-fd82-8116c3c57bf8&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:9;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:3:&quot;129&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:65:&quot;Re-roll patches to apply cleanly to the latest version of Drupal.&quot;;s:3:&quot;log&quot;;s:36:&quot;Fixed encoding on \' and &quot; characters&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;c8b84955-abf5-4d24-0d07-40e40ced94d3&quot;;s:3:&quot;nid&quot;;s:1:&quot;3&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330900883&quot;;s:7:&quot;changed&quot;;s:10:&quot;1352755140&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;b93deb54-264f-19a4-49eb-db74bc6c2712&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1352755140&quot;;s:12:&quot;revision_uid&quot;;s:2:&quot;68&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:8625:&quot;&lt;p&gt;Before getting started, it helps to have a basic understanding of what we\'re about to do with Git. Here\'s a brief overview of what\'s going on in Git during the patch re-rolling process.&lt;/p&gt;
&lt;p&gt;Every saved revision of a Git project is called a \'commit\'. Every commit in a project\'s history has an ID number (Figure 1.1).&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.1.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;When a new Drupal release comes out the project is tagged with the release number, for example,7.4, 7.5, 7.6, 7.7. A tag is just an alias for a commit ID. It is a human readable name assigned to a specific revision of the project. (Figure 1.2).&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.2.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Before re-rolling a patch, we will find a place in the project\'s history where the patch applies cleanly. (Figure 1.3)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.3.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Next we will create a local working branch, or \'topic\' branch, based on a version of the project where our patch applies cleanly. (Figure 1.4)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.4.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Then we merge in more recent changes from branch 7.x to our working branch and resolve any conflicts that arise during the merge. (Figure 1.5)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.5.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Finally, we re-roll the patch by getting the diff between our local branch and Drupal\'s development branch. Then we save the new diff as a patch and post it on drupal.org. &lt;/p&gt;
&lt;p&gt;(Figure 1.6 shows all the previous diagrams combined into one, in case it\'s helpful for reference.)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.6.png&quot; /&gt;&lt;/p&gt;
&lt;h3&gt;How To:&lt;/h3&gt;
&lt;p&gt;(Note: Examples below were written using Drupal 7 as an example. For work on Drupal core, you should really be using Drupal 8. Just type 8.x instead of 7.x following the examples below.)&lt;/p&gt;
&lt;ol&gt;
  &lt;li&gt;Go to the Drupal core issue queue and find patches that need to be reviewed by filtering the list of issues for \'needs review\'. (Example screen shot here.)&lt;/li&gt;
  &lt;li&gt;Make sure you\'re running the latest version of Drupal&lt;br /&gt;
    &lt;code&gt; cd /path/to/drupal&lt;br /&gt;
    git pull&lt;/code&gt;&lt;/li&gt;
  &lt;li&gt;Find a patch that was created a while ago. Download and try to apply the patch. If it applies cleanly, test it, then go back to step 1. If Git reports errors when trying to apply the patch, the patch needs to be re-rolled.&lt;/li&gt;
  &lt;li&gt;Next we need to get the patch to apply cleanly. Git checkout the version of Drupal the patch was created for. Note: Git will notify you that the checkout you are doing in this step puts Git in a \'detached head state.\' Detached head sounds  scary, but it\'s okay, this is what we want. (Example screenshot here.)&lt;br /&gt;
    If the patch was written for a tagged release of Drupal, getting the patch to apply cleanly is easy. This should be all you have to do:
    &lt;p&gt;&lt;code&gt; git checkout 7.4	 	# Replace 7.4 with your own release number.&lt;br /&gt;
      git apply -v /path/to/patch/example.patch&lt;/code&gt;&lt;/p&gt;
    &lt;p&gt;If the patch was written for the development branch (7.x) and the author specifies a commit in Drupal\'s project history where the patch applies cleanly, do this:&lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git checkout abcd1234	 	# Replace abcd1234 with the real commit ID.&lt;br /&gt;
      git apply -v /path/to/patch/example.patch&lt;/code&gt;&lt;/p&gt;
    &lt;p&gt;If the patch was written for the development branch (7.x) and the author does not specify a commit in Drupal\'s project history where the patch applies cleanly, we have some detective work to do. First, find the date when the patch was posted on d.o. Then checkout a version of Drupal that would have been available when the patch was written by doing this: &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git log --before=1/10/11      # Replace 1/10/11 with date patch was posted. &lt;br /&gt;
      # If you want to show a shorter list, you can specify how many&lt;br /&gt;
      # commits are displayed.&lt;br /&gt;
      git log --before=1/10/11 -5&lt;br /&gt;
      # You can also view a more condensed list like this:&lt;br /&gt;
      git log --before=1/10/11 --pretty=oneline&lt;br /&gt;
      git log --before=1/10/11 --pretty=oneline -5&lt;br /&gt;
      &lt;br /&gt;
      # Many terminals display Git\'s log with Less. Press \'q\' to exit Less.&lt;br /&gt;
      # Now checkout a commit that was available at the time the patch was &lt;br /&gt;
      # written and try applying the patch.&lt;br /&gt;
      git checkout abcd1234	# Replace abcd1234 with a real commit ID.&lt;br /&gt;
      git apply -v /path/to/example.patch&lt;br /&gt;
      &lt;br /&gt;
      # If the patch does not apply cleanly, &lt;br /&gt;
      # checkout an older commit and try again.&lt;br /&gt;
      git checkout efgh5678&lt;br /&gt;
      git apply -v /path/to/example.patch&lt;/code&gt;&lt;br /&gt;
    &lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Once you get the patch to apply cleanly, create your own local working branch.
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; # Create a new branch. Named [description]-[issue number]&lt;br /&gt;
      # This branch begins at the commit you checked out and includes&lt;br /&gt;
      # unsaved changes from the patch you applied.&lt;br /&gt;
      git checkout -b example-12345&lt;br /&gt;
      # Save the changes created by applying the patch.&lt;br /&gt;
      git commit -am \'Applying patch example.patch from drupal.org/node/09876.\'&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Now merge all the commits from branch 7.x into your branch.
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git merge 7.x&lt;/code&gt;&lt;/p&gt;
    &lt;p&gt;Git will report conflicts like this:&lt;/p&gt;
    &lt;p&gt;&lt;code&gt; Auto-merging includes/common.inc&lt;br /&gt;
      CONFLICT (content): Merge conflict in includes/common.inc&lt;br /&gt;
      Automatic merge failed; fix conflicts and then commit the result.&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Work through files with conflicts one-by-one. To see a list of files with outstanding conflicts do this (example):
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git diff --stat&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Now open one of the files with conflicts, manually resolve the conflicts, and then remove all the lines that look like this:
&lt;p&gt;&lt;code&gt;&amp;lt;&amp;lt;&amp;lt;&amp;lt;HEAD, =========, or &amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt;7.x.&lt;br /&gt; 
&amp;lt;&amp;lt;&amp;lt;&amp;lt;&amp;lt;&amp;lt;&amp;lt; HEAD&lt;br /&gt;
      [Your branch\'s version appears here.]&lt;br /&gt;
      =======&lt;br /&gt;
      [7.x\'s version appears here.]&lt;br /&gt;
      &amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt; 7.x&lt;br /&gt;&lt;/code&gt;
    &lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Stage your edits to be committed like this:
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git add path/to/fixed/file&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;See if there are any files with conflicts left to be fixed.
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git diff --stat&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;When all the files with conflicts have been fixed, save your work
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git commit -m \'Resolving conflicts between 7.x and example.patch\'&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Now create a new patch:
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; # Create a patch that will make branch 7.x like example-12345:&lt;br /&gt;
      git diff 7.x example-12345 &amp;gt; my-new.patch&lt;br /&gt;
      # If you\'re on example-12345, this does the same thing:&lt;br /&gt;
      git diff 7.x &amp;gt; my-new.patch&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Test your patch on branch 7.x to make sure it works. Then reset to clean up branch 7x.
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git checkout 7.x&lt;br /&gt;
      git apply path/to/my-new.patch&lt;br /&gt;
      git reset --hard&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Now upload your patch to drupal.org. As a courtesy. To the next person, please include a note to let them know where your patch applies cleanly. For example you can say something like: This patch applies cleanly at commit abcd1234. &lt;/li&gt;
&lt;/ol&gt;
&lt;h3&gt;Tips:&lt;/h3&gt;
&lt;ol&gt;
  &lt;li&gt;If you ever feel lost in Git, concerned about accidental changes, or want to start over for any reason, just do this:
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git checkout 7.x	# Checkout branch 7.x.&lt;br /&gt;
      git reset --hard		# Undo any uncommitted changes.&lt;br /&gt;
      git pull			# Sync your repository with the Git repo you cloned.&lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
  &lt;li&gt;Git quick reference (more)
    &lt;/p&gt;
    &lt;p&gt;&lt;code&gt; git branch 		# See what branch your on now, indicated by * &lt;br /&gt;
      git checkout 7.x		# Switch to branch 7.x &lt;br /&gt;
      git checkout 7.4		# Checkout Drupal release version 7.4&lt;br /&gt;
      git checkout abcd1234   # Checkout the code base at commit ID abcd1234 &lt;br /&gt;
      git checkout -b example # Create a new branch called \'example\' beginning with&lt;br /&gt;
      # the last commit in my current branch.&lt;br /&gt;
      git reset --hard		# Undo changes until the last commit.&lt;br /&gt;
      git log -3		# Show commit messages and IDs for the last three commits.&lt;br /&gt;
      git show abcd1234	# Show the message and diff for commit abcd1234&lt;br /&gt;
      git commit -am \'message\' &lt;/code&gt;&lt;/p&gt;
  &lt;/li&gt;
&lt;/ol&gt;&quot;;s:6:&quot;format&quot;;s:9:&quot;full_html&quot;;s:10:&quot;safe_value&quot;;s:8300:&quot;&lt;p&gt;Before getting started, it helps to have a basic understanding of what we\'re about to do with Git. Here\'s a brief overview of what\'s going on in Git during the patch re-rolling process.&lt;/p&gt;
&lt;p&gt;Every saved revision of a Git project is called a \'commit\'. Every commit in a project\'s history has an ID number (Figure 1.1).&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.1.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;When a new Drupal release comes out the project is tagged with the release number, for example,7.4, 7.5, 7.6, 7.7. A tag is just an alias for a commit ID. It is a human readable name assigned to a specific revision of the project. (Figure 1.2).&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.2.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Before re-rolling a patch, we will find a place in the project\'s history where the patch applies cleanly. (Figure 1.3)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.3.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Next we will create a local working branch, or \'topic\' branch, based on a version of the project where our patch applies cleanly. (Figure 1.4)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.4.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Then we merge in more recent changes from branch 7.x to our working branch and resolve any conflicts that arise during the merge. (Figure 1.5)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.5.png&quot; /&gt;&lt;/p&gt;
&lt;p&gt;Finally, we re-roll the patch by getting the diff between our local branch and Drupal\'s development branch. Then we save the new diff as a patch and post it on drupal.org. &lt;/p&gt;
&lt;p&gt;(Figure 1.6 shows all the previous diagrams combined into one, in case it\'s helpful for reference.)&lt;/p&gt;
&lt;p&gt;&lt;img src=&quot;http://drupal.org/files/figure1.6.png&quot; /&gt;&lt;/p&gt;
&lt;h3&gt;How To:&lt;/h3&gt;
&lt;p&gt;(Note: Examples below were written using Drupal 7 as an example. For work on Drupal core, you should really be using Drupal 8. Just type 8.x instead of 7.x following the examples below.)&lt;/p&gt;
&lt;ol&gt;&lt;li&gt;Go to the Drupal core issue queue and find patches that need to be reviewed by filtering the list of issues for \'needs review\'. (Example screen shot here.)&lt;/li&gt;
&lt;li&gt;Make sure you\'re running the latest version of Drupal&lt;br /&gt;&lt;code&gt; cd /path/to/drupal&lt;br /&gt;
    git pull&lt;/code&gt;&lt;/li&gt;
&lt;li&gt;Find a patch that was created a while ago. Download and try to apply the patch. If it applies cleanly, test it, then go back to step 1. If Git reports errors when trying to apply the patch, the patch needs to be re-rolled.&lt;/li&gt;
&lt;li&gt;Next we need to get the patch to apply cleanly. Git checkout the version of Drupal the patch was created for. Note: Git will notify you that the checkout you are doing in this step puts Git in a \'detached head state.\' Detached head sounds  scary, but it\'s okay, this is what we want. (Example screenshot here.)&lt;br /&gt;
    If the patch was written for a tagged release of Drupal, getting the patch to apply cleanly is easy. This should be all you have to do:
&lt;p&gt;&lt;code&gt; git checkout 7.4	 	# Replace 7.4 with your own release number.&lt;br /&gt;
      git apply -v /path/to/patch/example.patch&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;If the patch was written for the development branch (7.x) and the author specifies a commit in Drupal\'s project history where the patch applies cleanly, do this:&lt;/p&gt;
&lt;p&gt;&lt;code&gt; git checkout abcd1234	 	# Replace abcd1234 with the real commit ID.&lt;br /&gt;
      git apply -v /path/to/patch/example.patch&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;If the patch was written for the development branch (7.x) and the author does not specify a commit in Drupal\'s project history where the patch applies cleanly, we have some detective work to do. First, find the date when the patch was posted on d.o. Then checkout a version of Drupal that would have been available when the patch was written by doing this: &lt;/p&gt;
&lt;p&gt;&lt;code&gt; git log --before=1/10/11      # Replace 1/10/11 with date patch was posted. &lt;br /&gt;
      # If you want to show a shorter list, you can specify how many&lt;br /&gt;
      # commits are displayed.&lt;br /&gt;
      git log --before=1/10/11 -5&lt;br /&gt;
      # You can also view a more condensed list like this:&lt;br /&gt;
      git log --before=1/10/11 --pretty=oneline&lt;br /&gt;
      git log --before=1/10/11 --pretty=oneline -5&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;      # Many terminals display Git\'s log with Less. Press \'q\' to exit Less.&lt;br /&gt;
      # Now checkout a commit that was available at the time the patch was &lt;br /&gt;
      # written and try applying the patch.&lt;br /&gt;
      git checkout abcd1234	# Replace abcd1234 with a real commit ID.&lt;br /&gt;
      git apply -v /path/to/example.patch&lt;/p&gt;
&lt;p&gt;      # If the patch does not apply cleanly, &lt;br /&gt;
      # checkout an older commit and try again.&lt;br /&gt;
      git checkout efgh5678&lt;br /&gt;
      git apply -v /path/to/example.patch
    &lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Once you get the patch to apply cleanly, create your own local working branch.
    
&lt;p&gt;&lt;code&gt; # Create a new branch. Named [description]-[issue number]&lt;br /&gt;
      # This branch begins at the commit you checked out and includes&lt;br /&gt;
      # unsaved changes from the patch you applied.&lt;br /&gt;
      git checkout -b example-12345&lt;br /&gt;
      # Save the changes created by applying the patch.&lt;br /&gt;
      git commit -am \'Applying patch example.patch from drupal.org/node/09876.\'&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Now merge all the commits from branch 7.x into your branch.
    
&lt;p&gt;&lt;code&gt; git merge 7.x&lt;/code&gt;&lt;/p&gt;
&lt;p&gt;Git will report conflicts like this:&lt;/p&gt;
&lt;p&gt;&lt;code&gt; Auto-merging includes/common.inc&lt;br /&gt;
      CONFLICT (content): Merge conflict in includes/common.inc&lt;br /&gt;
      Automatic merge failed; fix conflicts and then commit the result.&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Work through files with conflicts one-by-one. To see a list of files with outstanding conflicts do this (example):
    
&lt;p&gt;&lt;code&gt; git diff --stat&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Now open one of the files with conflicts, manually resolve the conflicts, and then remove all the lines that look like this:
&lt;p&gt;&lt;code&gt;&amp;lt;&amp;lt;&amp;lt;&amp;lt;HEAD, =========, or &amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt;7.x.&lt;br /&gt;&lt;br /&gt;
&amp;lt;&amp;lt;&amp;lt;&amp;lt;&amp;lt;&amp;lt;&amp;lt; HEAD&lt;br /&gt;
      [Your branch\'s version appears here.]&lt;br /&gt;
      =======&lt;br /&gt;
      [7.x\'s version appears here.]&lt;br /&gt;
      &amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt;&amp;gt; 7.x&lt;br /&gt;&lt;/code&gt;
    &lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Stage your edits to be committed like this:
    
&lt;p&gt;&lt;code&gt; git add path/to/fixed/file&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;See if there are any files with conflicts left to be fixed.
    
&lt;p&gt;&lt;code&gt; git diff --stat&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;When all the files with conflicts have been fixed, save your work
    
&lt;p&gt;&lt;code&gt; git commit -m \'Resolving conflicts between 7.x and example.patch\'&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Now create a new patch:
    
&lt;p&gt;&lt;code&gt; # Create a patch that will make branch 7.x like example-12345:&lt;br /&gt;
      git diff 7.x example-12345 &amp;gt; my-new.patch&lt;br /&gt;
      # If you\'re on example-12345, this does the same thing:&lt;br /&gt;
      git diff 7.x &amp;gt; my-new.patch&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Test your patch on branch 7.x to make sure it works. Then reset to clean up branch 7x.
    
&lt;p&gt;&lt;code&gt; git checkout 7.x&lt;br /&gt;
      git apply path/to/my-new.patch&lt;br /&gt;
      git reset --hard&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Now upload your patch to drupal.org. As a courtesy. To the next person, please include a note to let them know where your patch applies cleanly. For example you can say something like: This patch applies cleanly at commit abcd1234. &lt;/li&gt;
&lt;/ol&gt;&lt;h3&gt;Tips:&lt;/h3&gt;
&lt;ol&gt;&lt;li&gt;If you ever feel lost in Git, concerned about accidental changes, or want to start over for any reason, just do this:
    
&lt;p&gt;&lt;code&gt; git checkout 7.x	# Checkout branch 7.x.&lt;br /&gt;
      git reset --hard		# Undo any uncommitted changes.&lt;br /&gt;
      git pull			# Sync your repository with the Git repo you cloned.&lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;li&gt;Git quick reference (more)
    
&lt;p&gt;&lt;code&gt; git branch 		# See what branch your on now, indicated by * &lt;br /&gt;
      git checkout 7.x		# Switch to branch 7.x &lt;br /&gt;
      git checkout 7.4		# Checkout Drupal release version 7.4&lt;br /&gt;
      git checkout abcd1234   # Checkout the code base at commit ID abcd1234 &lt;br /&gt;
      git checkout -b example # Create a new branch called \'example\' beginning with&lt;br /&gt;
      # the last commit in my current branch.&lt;br /&gt;
      git reset --hard		# Undo changes until the last commit.&lt;br /&gt;
      git log -3		# Show commit messages and IDs for the last three commits.&lt;br /&gt;
      git show abcd1234	# Show the message and diff for commit abcd1234&lt;br /&gt;
      git commit -am \'message\' &lt;/code&gt;&lt;/p&gt;
&lt;/li&gt;
&lt;/ol&gt;&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:1:{s:3:&quot;und&quot;;a:3:{i:0;a:1:{s:5:&quot;value&quot;;s:1:&quot;6&quot;;}i:1;a:1:{s:5:&quot;value&quot;;s:1:&quot;7&quot;;}i:2;a:1:{s:5:&quot;value&quot;;s:1:&quot;8&quot;;}}}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;other&quot;;}}}s:17:&quot;field_lesson_type&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:4:&quot;code&quot;;}}}s:26:&quot;field_lesson_prerequisites&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:555:&quot;&lt;ul&gt;
&lt;li&gt;Git checkout of Drupal 8 code base. (&lt;a href=&quot;http://drupal.org/project/drupal/git-instructions&quot;&gt;instructions&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;Know how to and &lt;a href=&quot;https://docs.google.com/document/d/1RdN-sIb2lvohxFbo2VTFtI-Gs38XHdpDsJBgk7oNzug/edit?hl=en_US&quot;&gt;apply and test patches&lt;/a&gt;.&lt;/li&gt;
&lt;li&gt;(Helpful but not required) Knowledge of Git &lt;a href=&quot;http://learn.github.com/p/branching.html&quot;&gt;branching and merging&lt;/a&gt;, &lt;a href=&quot;http://learn.github.com/p/tagging.html&quot;&gt;tagging&lt;/a&gt; and &lt;a href=&quot;http://learn.github.com/p/rebasing.html&quot;&gt;rebasing&lt;/a&gt;.&lt;/li&gt;
&lt;/ul&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:550:&quot;&lt;ul&gt;&lt;li&gt;Git checkout of Drupal 8 code base. (&lt;a href=&quot;http://drupal.org/project/drupal/git-instructions&quot;&gt;instructions&lt;/a&gt;)&lt;/li&gt;
&lt;li&gt;Know how to and &lt;a href=&quot;https://docs.google.com/document/d/1RdN-sIb2lvohxFbo2VTFtI-Gs38XHdpDsJBgk7oNzug/edit?hl=en_US&quot;&gt;apply and test patches&lt;/a&gt;.&lt;/li&gt;
&lt;li&gt;(Helpful but not required) Knowledge of Git &lt;a href=&quot;http://learn.github.com/p/branching.html&quot;&gt;branching and merging&lt;/a&gt;, &lt;a href=&quot;http://learn.github.com/p/tagging.html&quot;&gt;tagging&lt;/a&gt; and &lt;a href=&quot;http://learn.github.com/p/rebasing.html&quot;&gt;rebasing&lt;/a&gt;.&lt;/li&gt;
&lt;/ul&gt;&quot;;}}}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:626:&quot;&lt;p&gt;In the time it takes to get a patch written, tested, reviewed, etc. Drupal continues evolving. As Drupal evolves, the patches must be kept up to date. For example, imagine a patch that was originally created to make some edits to line 5 in file X. Two releases later the patch should actually edit line 10, not line 5. Now the patch has to be updated, or &quot;re-rolled&quot;. Sometimes re-rolling a patch is complex, but usually it\'s pretty simple. Git provides some handy tools that will let you apply the patch to the version of Drupal it was written for, merge the changes into a newer version, and then re-create the patch.&lt;/p&gt;&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:627:&quot;&lt;p&gt;In the time it takes to get a patch written, tested, reviewed, etc. Drupal continues evolving. As Drupal evolves, the patches must be kept up to date. For example, imagine a patch that was originally created to make some edits to line 5 in file X. Two releases later the patch should actually edit line 10, not line 5. Now the patch has to be updated, or &quot;re-rolled&quot;. Sometimes re-rolling a patch is complex, but usually it\'s pretty simple. Git provides some handy tools that will let you apply the patch to the version of Drupal it was written for, merge the changes into a newer version, and then re-create the patch.&lt;/p&gt;
&quot;;}}}s:24:&quot;field_lesson_description&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:74:&quot;Learn to update or &quot;re-roll&quot; patches to apply to a newer version of Drupal&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:84:&quot;Learn to update or &amp;quot;re-roll&amp;quot; patches to apply to a newer version of Drupal&quot;;}}}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;up-to-date&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:10:&quot;1347913626&quot;;}}}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:3:&quot;180&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1353601803&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:4:&quot;5625&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;2&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:1:&quot;6&quot;;s:6:&quot;source&quot;;s:6:&quot;node/3&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/b93deb54-264f-19a4-49eb-db74bc6c2712&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:10;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:2:&quot;15&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:44:&quot;Join an initiative (for a set of components)&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;0747cd45-706e-1444-5de0-9e6961030633&quot;;s:3:&quot;nid&quot;;s:2:&quot;15&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903350&quot;;s:7:&quot;changed&quot;;s:10:&quot;1344940738&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;de7dca9e-7b05-a934-4558-818813bd0619&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1344940738&quot;;s:12:&quot;revision_uid&quot;;s:1:&quot;1&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:36:&quot;This lesson has not been written yet&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:44:&quot;&lt;p&gt;This lesson has not been written yet&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:0:{}s:21:&quot;field_lesson_overview&quot;;a:0:{}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;draft&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:0:{}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:1:&quot;0&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1330903350&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:1:&quot;1&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;0&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;18&quot;;s:6:&quot;source&quot;;s:7:&quot;node/15&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/de7dca9e-7b05-a934-4558-818813bd0619&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:11;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:2:&quot;16&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:44:&quot;Own a project (core component or initiative)&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;678ecc45-e590-5954-6dac-95a0573c4a30&quot;;s:3:&quot;nid&quot;;s:2:&quot;16&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903366&quot;;s:7:&quot;changed&quot;;s:10:&quot;1344940729&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;e0a5e06e-d0f0-d364-d9ef-7193e5393410&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1344940729&quot;;s:12:&quot;revision_uid&quot;;s:1:&quot;1&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:36:&quot;This lesson has not been written yet&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:44:&quot;&lt;p&gt;This lesson has not been written yet&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:0:{}s:21:&quot;field_lesson_overview&quot;;a:0:{}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:5:&quot;draft&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:0:{}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:1:&quot;0&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1330903366&quot;;s:17:&quot;last_comment_name&quot;;N;s:16:&quot;last_comment_uid&quot;;s:1:&quot;1&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;0&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;19&quot;;s:6:&quot;source&quot;;s:7:&quot;node/16&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/e0a5e06e-d0f0-d364-d9ef-7193e5393410&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:12;O:8:&quot;stdClass&quot;:34:{s:3:&quot;vid&quot;;s:2:&quot;17&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:13:&quot;Drupal Ladder&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;4c98abeb-c64e-64d4-d516-c0ed11b1846e&quot;;s:3:&quot;nid&quot;;s:2:&quot;17&quot;;s:4:&quot;type&quot;;s:6:&quot;ladder&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903481&quot;;s:7:&quot;changed&quot;;s:10:&quot;1356364088&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;ee503327-50be-1904-8d04-9499098cad64&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1356364088&quot;;s:12:&quot;revision_uid&quot;;s:1:&quot;0&quot;;s:24:&quot;field_ladder_maintainers&quot;;a:0:{}s:21:&quot;field_lesson_overview&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:255:&quot;This ladder teaches essential skills for contributing to Drupal 8 Core. Start on the bottom rung if you are a beginner, and climb as you acquire the skills and knowledge described in each lesson. Contribute your improvements at drupal.org/project/lessons.&quot;;s:6:&quot;format&quot;;N;s:10:&quot;safe_value&quot;;s:255:&quot;This ladder teaches essential skills for contributing to Drupal 8 Core. Start on the bottom rung if you are a beginner, and climb as you acquire the skills and knowledge described in each lesson. Contribute your improvements at drupal.org/project/lessons.&quot;;}}}s:13:&quot;field_lessons&quot;;a:1:{s:3:&quot;und&quot;;a:14:{i:0;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;16&quot;;}i:1;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;15&quot;;}i:2;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;14&quot;;}i:3;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;13&quot;;}i:4;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;12&quot;;}i:5;a:1:{s:9:&quot;target_id&quot;;s:1:&quot;3&quot;;}i:6;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;11&quot;;}i:7;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;10&quot;;}i:8;a:1:{s:9:&quot;target_id&quot;;s:2:&quot;30&quot;;}i:9;a:1:{s:9:&quot;target_id&quot;;s:1:&quot;7&quot;;}i:10;a:1:{s:9:&quot;target_id&quot;;s:1:&quot;6&quot;;}i:11;a:1:{s:9:&quot;target_id&quot;;s:1:&quot;4&quot;;}i:12;a:1:{s:9:&quot;target_id&quot;;s:1:&quot;5&quot;;}i:13;a:1:{s:9:&quot;target_id&quot;;s:1:&quot;9&quot;;}}}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:1:&quot;0&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1330903481&quot;;s:17:&quot;last_comment_name&quot;;N;s:16:&quot;last_comment_uid&quot;;s:1:&quot;1&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;0&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;20&quot;;s:6:&quot;source&quot;;s:7:&quot;node/17&quot;;s:5:&quot;alias&quot;;s:43:&quot;ladder/ee503327-50be-1904-8d04-9499098cad64&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}i:13;O:8:&quot;stdClass&quot;:43:{s:3:&quot;vid&quot;;s:2:&quot;12&quot;;s:3:&quot;uid&quot;;s:1:&quot;1&quot;;s:5:&quot;title&quot;;s:11:&quot;Write tests&quot;;s:3:&quot;log&quot;;s:0:&quot;&quot;;s:6:&quot;status&quot;;s:1:&quot;1&quot;;s:7:&quot;comment&quot;;s:1:&quot;2&quot;;s:7:&quot;promote&quot;;s:1:&quot;1&quot;;s:6:&quot;sticky&quot;;s:1:&quot;0&quot;;s:5:&quot;vuuid&quot;;s:36:&quot;54853770-c0b7-87b4-85bc-84e588454283&quot;;s:3:&quot;nid&quot;;s:2:&quot;12&quot;;s:4:&quot;type&quot;;s:6:&quot;lesson&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;s:7:&quot;created&quot;;s:10:&quot;1330903249&quot;;s:7:&quot;changed&quot;;s:10:&quot;1344807453&quot;;s:4:&quot;tnid&quot;;s:1:&quot;0&quot;;s:9:&quot;translate&quot;;s:1:&quot;0&quot;;s:4:&quot;uuid&quot;;s:36:&quot;f6499034-7520-2db4-6522-c32c8429e2d7&quot;;s:18:&quot;revision_timestamp&quot;;s:10:&quot;1344807453&quot;;s:12:&quot;revision_uid&quot;;s:1:&quot;0&quot;;s:18:&quot;field_lesson_steps&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:3:{s:5:&quot;value&quot;;s:37:&quot;This lesson has not been written yet.&quot;;s:6:&quot;format&quot;;s:13:&quot;filtered_html&quot;;s:10:&quot;safe_value&quot;;s:45:&quot;&lt;p&gt;This lesson has not been written yet.&lt;/p&gt;
&quot;;}}}s:27:&quot;field_lesson_drupal_version&quot;;a:0:{}s:25:&quot;field_lesson_project_name&quot;;a:0:{}s:25:&quot;field_lesson_project_type&quot;;a:0:{}s:17:&quot;field_lesson_type&quot;;a:0:{}s:26:&quot;field_lesson_prerequisites&quot;;a:0:{}s:21:&quot;field_lesson_overview&quot;;a:0:{}s:24:&quot;field_lesson_description&quot;;a:0:{}s:17:&quot;field_lesson_tags&quot;;a:0:{}s:25:&quot;field_lesson_draft_status&quot;;a:1:{s:3:&quot;und&quot;;a:1:{i:0;a:1:{s:5:&quot;value&quot;;s:13:&quot;not-available&quot;;}}}s:29:&quot;field_lesson_last_peer_review&quot;;a:0:{}s:24:&quot;field_lesson_maintainers&quot;;a:0:{}s:11:&quot;rdf_mapping&quot;;a:9:{s:7:&quot;rdftype&quot;;a:2:{i:0;s:9:&quot;sioc:Item&quot;;i:1;s:13:&quot;foaf:Document&quot;;}s:5:&quot;title&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:8:&quot;dc:title&quot;;}}s:7:&quot;created&quot;;a:3:{s:10:&quot;predicates&quot;;a:2:{i:0;s:7:&quot;dc:date&quot;;i:1;s:10:&quot;dc:created&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:7:&quot;changed&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:11:&quot;dc:modified&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}s:4:&quot;body&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:15:&quot;content:encoded&quot;;}}s:3:&quot;uid&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:has_creator&quot;;}s:4:&quot;type&quot;;s:3:&quot;rel&quot;;}s:4:&quot;name&quot;;a:1:{s:10:&quot;predicates&quot;;a:1:{i:0;s:9:&quot;foaf:name&quot;;}}s:13:&quot;comment_count&quot;;a:2:{s:10:&quot;predicates&quot;;a:1:{i:0;s:16:&quot;sioc:num_replies&quot;;}s:8:&quot;datatype&quot;;s:11:&quot;xsd:integer&quot;;}s:13:&quot;last_activity&quot;;a:3:{s:10:&quot;predicates&quot;;a:1:{i:0;s:23:&quot;sioc:last_activity_date&quot;;}s:8:&quot;datatype&quot;;s:12:&quot;xsd:dateTime&quot;;s:8:&quot;callback&quot;;s:12:&quot;date_iso8601&quot;;}}s:3:&quot;cid&quot;;s:2:&quot;26&quot;;s:22:&quot;last_comment_timestamp&quot;;s:10:&quot;1332789280&quot;;s:17:&quot;last_comment_name&quot;;s:0:&quot;&quot;;s:16:&quot;last_comment_uid&quot;;s:2:&quot;34&quot;;s:13:&quot;comment_count&quot;;s:1:&quot;1&quot;;s:4:&quot;name&quot;;s:5:&quot;admin&quot;;s:7:&quot;picture&quot;;s:1:&quot;0&quot;;s:4:&quot;data&quot;;s:4:&quot;b:0;&quot;;s:4:&quot;path&quot;;a:4:{s:3:&quot;pid&quot;;s:2:&quot;15&quot;;s:6:&quot;source&quot;;s:7:&quot;node/12&quot;;s:5:&quot;alias&quot;;s:43:&quot;lesson/f6499034-7520-2db4-6522-c32c8429e2d7&quot;;s:8:&quot;language&quot;;s:3:&quot;und&quot;;}s:4:&quot;menu&quot;;a:14:{s:10:&quot;link_title&quot;;s:0:&quot;&quot;;s:4:&quot;mlid&quot;;i:0;s:4:&quot;plid&quot;;i:0;s:9:&quot;menu_name&quot;;s:9:&quot;main-menu&quot;;s:6:&quot;weight&quot;;i:0;s:7:&quot;options&quot;;a:0:{}s:6:&quot;module&quot;;s:4:&quot;menu&quot;;s:8:&quot;expanded&quot;;i:0;s:6:&quot;hidden&quot;;i:0;s:12:&quot;has_children&quot;;i:0;s:10:&quot;customized&quot;;i:0;s:18:&quot;parent_depth_limit&quot;;i:8;s:11:&quot;description&quot;;s:0:&quot;&quot;;s:7:&quot;enabled&quot;;i:1;}s:26:&quot;node_export_drupal_version&quot;;s:1:&quot;7&quot;;}}',
);
  return $node_export;
}
